#<profile4xi profile = "11" /> 
# -------------------------------------------------------------------------------------------------
#<program4xi program = "shoot2five4xi.py">
#<abstract4xi abstract = "shoots to direction five"/>
#<refer4xi reference = "verb4xi.py"/>
#<state4xi status = "ACK4tagging; ACK4moduletesting; NACK4systemtesting; [Rel 7.21]"/>
# -------------------------------------------------------------------------------------------------

# -------------------------------------------------------------------------------------------------
# Public API
# -------------------------------------------------------------------------------------------------
#<interface4xi interface = " 
__all__ = [ 'shoot2five4xi']
#"
#/>


# -------------------------------------------------------------------------------------------------
# Standard Imports                          
# -------------------------------------------------------------------------------------------------
#<standardize4xi standard = "
import os
import sys
import threading                
import _thread
import _winapi
   

import signal
import itertools
import weakref
import logging 

from math import pi
from math import sin
from math import cos 
from math import fabs
#"
#/>

# -------------------------------------------------------------------------------------------------
# DragonXi imports                              
# -------------------------------------------------------------------------------------------------
#<dragonize4xi dragonization = "

from sphere4xi import init_sphere2five4xi 
from sphere4xi import set_sphere2five4xi 
from sphere4xi import get_sphere2five4xi 

from time4xi import time4xi

#"
#/>

# -------------------------------------------------------------------------------------------------
# Global constants                            
# ------------------------------------------------------------------------------------------------
#<globalize4xi globalization = "
       
# -------------------------------------------------------------------------------------------------
# SHOT2FIVE - COORDINATE SIGNS OF SHOOT2FIVE4XI: (X - ,Y + ,Z + )
# -------------------------------------------------------------------------------------------------    
global shot2five104xi            # 10   - 90 
global shot2five1004xi           # 100  -    
global shot2five2004xi    
global shot2five3004xi
global shot2five4004xi
global shot2five5004xi
global shot2five6004xi
global shot2five7004xi
global shot2five8004xi
global shot2five9004xi
global shot2five10004xi            
global shot2five11004xi
global shot2five12004xi
global shot2five13004xi
global shot2five14004xi
global shot2five15004xi
global shot2five16004xi
global shot2five17004xi
global shot2five18004xi
global shot2five19004xi
global shot2five20004xi
global shot2five21004xi
global shot2five22004xi
global shot2five23004xi
global shot2five24004xi
global shot2five25004xi
global shot2five26004xi
global shot2five27004xi
global shot2five28004xi
global shot2five29004xi
global shot2five30004xi
global shot2five31004xi
global shot2five32004xi
global shot2five33004xi




#"
#/>

# -------------------------------------------------------------------------------------------------
# Settings
# -------------------------------------------------------------------------------------------------
#<set4xi setting = "
       
# -------------------------------------------------------------------------------------------------
# SHOT2FIVE - COORDINATE SIGNS OF SHOOT2FIVE4XI: (X - ,Y + ,Z + ) - READ FROM FILES
# -------------------------------------------------------------------------------------------------    

shot2five104xi = {
                1: '-10x10y12z',
                2: '-10x12y36z',
                3: '-10x45y17z',
                4: '-11x10y12z',
                5: '-11x11y36z',
                6: '-11x49y61z',
                7: '-12x11y36z',
                8: '-12x45y17z',
                9: '-12x9y12z',
                10: '-13x11y35z',
                11: '-13x49y61z',
                12: '-13x7y12z',
                13: '-13x8y12z',
                14: '-14x10y35z',
                15: '-14x6y11z',
                16: '-14x7y11z',
                17: '-15x4y11z',
                18: '-15x5y11z',
                19: '-15x9y35z',
                20: '-16x3y11z',
                21: '-16x49y60z',
                22: '-16x8y35z',
                23: '-16x9y35z',
                24: '-17x7y35z',
                25: '-18x53y19z',
                26: '-1x0y79z',
                27: '-1x6y7z',
                28: '-1x9y28z',
                29: '-21x52y19z',
                30: '-22x55y67z',
                31: '-22x8y43z',
                32: '-23x51y18z',
                33: '-23x7y43z',
                34: '-24x3y16z',
                35: '-24x6y43z',
                36: '-25x0y15z',
                37: '-25x1y15z',
                38: '-25x2y16z',
                39: '-25x4y42z',
                40: '-25x5y42z',
                41: '-26x2y42z',
                42: '-26x50y18z',
                43: '-27x0y41z',
                44: '-27x1y42z',
                45: '-29x49y17z',
                46: '-2x0y79z',
                47: '-2x6y6z',
                48: '-2x6y7z',
                49: '-2x9y28z',
                50: '-31x47y17z',
                51: '-34x46y16z',
                52: '-37x44y15z',
                53: '-39x42y15z',
                54: '-3x0y79z',
                55: '-3x6y6z',
                56: '-3x9y28z',
                57: '-41x40y14z',
                58: '-43x38y14z',
                59: '-45x36y13z',
                60: '-4x0y79z',
                61: '-4x5y6z',
                62: '-4x6y6z',
                63: '-4x9y27z',
                64: '-4x9y28z',
                65: '-55x39y15z',
                66: '-57x36y14z',
                67: '-59x33y13z',
                68: '-5x0y79z',
                69: '-5x46y18z',
                70: '-5x5y6z',
                71: '-5x9y27z',
                72: '-61x30y13z',
                73: '-63x27y12z',
                74: '-64x23y11z',
                75: '-66x20y11z',
                76: '-67x13y9z',
                77: '-67x17y10z',
                78: '-68x9y9z',
                79: '-69x2y7z',
                80: '-69x6y8z',
                81: '-6x0y79z',
                82: '-7x0y79z',
                83: '-7x45y18z',
                84: '-8x12y36z',
                85: '-8x49y62z',
                86: '-9x12y36z',
                87: '0x0y79z',
                88: '0x6y7z',
                89: '0x8y28z'}
       

shot2five1004xi = {
                1: '-10x31y94z',
                2: '-10x62y77z',
                3: '-10x67y72z',
                4: '-10x92y37z',
                5: '-12x32y93z',
                6: '-14x32y93z',
                7: '-14x62y76z',
                8: '-14x67y72z',
                9: '-159x14y119z',
                10: '-15x91y36z',
                11: '-16x32y93z',
                12: '-17x62y76z',
                13: '-18x32y92z',
                14: '-18x67y71z',
                15: '-1x0y99z',
                16: '-20x32y92z',
                17: '-20x61y75z',
                18: '-20x91y35z',
                19: '-21x67y70z',
                20: '-22x31y92z',
                21: '-24x61y75z',
                22: '-25x31y91z',
                23: '-25x66y70z',
                24: '-25x90y34z',
                25: '-27x30y91z',
                26: '-27x60y74z',
                27: '-29x29y90z',
                28: '-29x65y69z',
                29: '-2x0y99z',
                30: '-30x89y33z',
                31: '-31x28y90z',
                32: '-31x59y73z',
                33: '-32x64y68z',
                34: '-33x27y89z',
                35: '-34x58y72z',
                36: '-35x26y89z',
                37: '-35x87y32z',
                38: '-36x63y67z',
                39: '-38x24y89z',
                40: '-38x57y72z',
                41: '-39x86y31z',
                42: '-3x0y99z',
                43: '-3x29y95z',
                44: '-40x23y88z',
                45: '-40x62y67z',
                46: '-41x21y88z',
                47: '-41x55y71z',
                48: '-43x19y87z',
                49: '-43x60y66z',
                50: '-44x84y30z',
                51: '-45x17y87z',
                52: '-45x54y70z',
                53: '-47x15y86z',
                54: '-47x58y65z',
                55: '-48x13y86z',
                56: '-48x52y70z',
                57: '-48x82y29z',
                58: '-4x0y99z',
                59: '-4x30y95z',
                60: '-50x10y85z',
                61: '-50x56y64z',
                62: '-51x50y69z',
                63: '-51x8y85z',
                64: '-52x5y84z',
                65: '-53x79y28z',
                66: '-54x0y83z',
                67: '-54x3y84z',
                68: '-54x47y68z',
                69: '-54x54y64z',
                70: '-57x45y68z',
                71: '-57x51y63z',
                72: '-57x76y27z',
                73: '-5x0y99z',
                74: '-60x42y67z',
                75: '-60x49y62z',
                76: '-61x74y26z',
                77: '-63x39y66z',
                78: '-63x46y61z',
                79: '-65x36y65z',
                80: '-65x70y25z',
                81: '-66x43y61z',
                82: '-68x33y65z',
                83: '-69x39y60z',
                84: '-69x67y24z',
                85: '-6x0y99z',
                86: '-6x30y94z',
                87: '-70x30y64z',
                88: '-71x36y59z',
                89: '-72x26y63z',
                90: '-73x32y58z',
                91: '-73x64y23z',
                92: '-74x23y62z',
                93: '-76x19y61z',
                94: '-76x29y57z',
                95: '-76x60y22z',
                96: '-77x15y61z',
                97: '-78x11y60z',
                98: '-78x25y57z',
                99: '-79x21y56z',
                100: '-79x56y21z',
                101: '-7x0y99z',
                102: '-7x67y73z',
                103: '-81x17y55z',
                104: '-82x13y54z',
                105: '-82x52y20z',
                106: '-83x8y53z',
                107: '-84x4y52z',
                108: '-85x0y52z',
                109: '-85x47y19z',
                110: '-88x43y18z',
                111: '-8x0y99z',
                112: '-8x31y94z',
                113: '-90x38y17z',
                114: '-92x34y16z',
                115: '-94x29y15z',
                116: '-95x24y14z',
                117: '-97x19y13z',
                118: '-98x14y12z',
                119: '-98x9y11z',
                120: '-99x3y10z',
                121: '-9x0y99z',
                122: '0x0y99z'}


shot2five2004xi = {
                1: '-100x21y171z',
                2: '-101x112y129z',
                3: '-102x100y138z',
                4: '-103x16y170z',
                5: '-105x11y169z',
                6: '-106x159y57z',
                7: '-108x108y128z',
                8: '-108x6y168z',
                9: '-109x0y167z',
                10: '-109x95y137z',
                11: '-10x1y199z',
                12: '-114x103y126z',
                13: '-115x153y55z',
                14: '-115x90y136z',
                15: '-120x85y134z',
                16: '-121x98y125z',
                17: '-123x148y53z',
                18: '-126x79y133z',
                19: '-127x92y123z',
                20: '-12x0y199z',
                21: '-12x61y189z',
                22: '-131x141y51z',
                23: '-131x73y131z',
                24: '-132x86y122z',
                25: '-136x67y130z',
                26: '-138x135y49z',
                27: '-138x79y120z',
                28: '-140x60y128z',
                29: '-143x72y118z',
                30: '-144x53y127z',
                31: '-146x128y47z',
                32: '-147x65y117z',
                33: '-148x46y125z',
                34: '-14x0y199z',
                35: '-14x134y147z',
                36: '-152x38y123z',
                37: '-152x58y115z',
                38: '-153x120y45z',
                39: '-155x30y122z',
                40: '-156x50y114z',
                41: '-157x22y120z',
                42: '-159x112y43z',
                43: '-159x14y119z',
                44: '-159x42y112z',
                45: '-162x34y110z',
                46: '-165x104y41z',
                47: '-165x26y109z',
                48: '-167x17y107z',
                49: '-169x8y105z',
                50: '-16x0y199z',
                51: '-16x62y189z',
                52: '-170x0y104z',
                53: '-171x95y39z',
                54: '-176x86y37z',
                55: '-180x77y35z',
                56: '-184x68y33z',
                57: '-188x58y31z',
                58: '-191x48y29z',
                59: '-194x38y27z',
                60: '-196x28y25z',
                61: '-197x18y23z',
                62: '-198x7y21z',
                63: '-20x63y188z',
                64: '-21x124y155z',
                65: '-21x135y145z',
                66: '-21x184y74z',
                67: '-242x9y176z',
                68: '-24x64y187z',
                69: '-28x124y153z',
                70: '-28x135y144z',
                71: '-28x64y187z',
                72: '-2x0y199z',
                73: '-31x183y72z',
                74: '-32x64y186z',
                75: '-34x124y152z',
                76: '-36x134y143z',
                77: '-37x64y185z',
                78: '-41x123y151z',
                79: '-41x182y70z',
                80: '-41x64y184z',
                81: '-43x134y141z',
                82: '-45x63y184z',
                83: '-48x122y150z',
                84: '-4x1y199z',
                85: '-50x62y183z',
                86: '-51x133y140z',
                87: '-51x180y68z',
                88: '-54x60y182z',
                89: '-55x121y148z',
                90: '-58x131y138z',
                91: '-58x59y181z',
                92: '-60x178y66z',
                93: '-62x119y147z',
                94: '-63x57y180z',
                95: '-65x129y137z',
                96: '-67x55y179z',
                97: '-69x117y145z',
                98: '-6x1y199z',
                99: '-6x59y190z',
                100: '-70x175y64z',
                101: '-71x52y179z',
                102: '-73x127y135z',
                103: '-76x114y144z',
                104: '-76x49y178z',
                105: '-79x172y62z',
                106: '-80x124y134z',
                107: '-80x46y177z',
                108: '-83x111y143z',
                109: '-83x43y176z',
                110: '-87x120y132z',
                111: '-87x39y175z',
                112: '-88x168y60z',
                113: '-8x1y199z',
                114: '-90x108y141z',
                115: '-91x35y174z',
                116: '-94x117y131z',
                117: '-94x31y173z',
                118: '-96x104y140z',
                119: '-97x164y58z',
                120: '-97x26y172z',
                121: '-9x60y190z',
                122: '0x0y199z'}


shot2five3004xi = {
                1: '-101x82y269z',
                2: '-104x176y218z',
                3: '-105x263y97z',
                4: '-107x78y268z',
                5: '-110x190y203z',
                6: '-114x74y267z',
                7: '-115x172y216z',
                8: '-119x258y94z',
                9: '-120x186y201z',
                10: '-120x69y265z',
                11: '-125x167y214z',
                12: '-125x64y264z',
                13: '-12x2y299z',
                14: '-131x181y199z',
                15: '-131x59y263z',
                16: '-133x252y91z',
                17: '-135x162y212z',
                18: '-136x53y261z',
                19: '-141x46y260z',
                20: '-142x175y197z',
                21: '-144x156y210z',
                22: '-146x246y88z',
                23: '-146x39y258z',
                24: '-14x90y285z',
                25: '-151x32y257z',
                26: '-152x169y194z',
                27: '-154x150y208z',
                28: '-155x25y255z',
                29: '-158x17y253z',
                30: '-159x239y85z',
                31: '-15x1y299z',
                32: '-162x162y192z',
                33: '-162x9y252z',
                34: '-163x143y206z',
                35: '-164x0y250z',
                36: '-172x136y204z',
                37: '-172x155y190z',
                38: '-172x230y82z',
                39: '-181x128y201z',
                40: '-181x147y187z',
                41: '-185x222y79z',
                42: '-189x119y199z',
                43: '-18x1y299z',
                44: '-190x138y185z',
                45: '-196x212y76z',
                46: '-197x110y197z',
                47: '-199x129y183z',
                48: '-19x92y284z',
                49: '-204x100y195z',
                50: '-207x119y180z',
                51: '-208x202y74z',
                52: '-211x90y192z',
                53: '-214x109y178z',
                54: '-217x80y190z',
                55: '-219x192y71z',
                56: '-21x0y299z',
                57: '-21x201y220z',
                58: '-221x98y176z',
                59: '-223x69y188z',
                60: '-228x58y185z',
                61: '-228x87y173z',
                62: '-229x180y68z',
                63: '-232x46y183z',
                64: '-234x76y171z',
                65: '-236x34y181z',
                66: '-239x168y65z',
                67: '-239x22y178z',
                68: '-239x64y168z',
                69: '-242x9y176z',
                70: '-244x51y166z',
                71: '-248x156y62z',
                72: '-248x39y163z',
                73: '-24x94y283z',
                74: '-251x26y161z',
                75: '-254x13y158z',
                76: '-256x0y156z',
                77: '-256x143y59z',
                78: '-264x130y56z',
                79: '-271x116y53z',
                80: '-277x102y50z',
                81: '-282x87y47z',
                82: '-287x72y44z',
                83: '-291x57y41z',
                84: '-294x42y38z',
                85: '-296x27y35z',
                86: '-297x11y32z',
                87: '-30x95y282z',
                88: '-31x186y232z',
                89: '-32x202y218z',
                90: '-32x276y111z',
                91: '-36x96y281z',
                92: '-3x1y299z',
                93: '-42x186y230z',
                94: '-42x97y280z',
                95: '-43x202y216z',
                96: '-47x275y108z',
                97: '-49x97y279z',
                98: '-52x186y228z',
                99: '-54x202y214z',
                100: '-55x96y278z',
                101: '-62x185y227z',
                102: '-62x273y105z',
                103: '-62x96y277z',
                104: '-65x201y212z',
                105: '-68x95y276z',
                106: '-6x1y299z',
                107: '-73x184y225z',
                108: '-74x392y7z',
                109: '-75x93y274z',
                110: '-76x199y210z',
                111: '-76x271y102z',
                112: '-81x91y273z',
                113: '-83x182y223z',
                114: '-87x197y208z',
                115: '-88x88y272z',
                116: '-91x267y99z',
                117: '-94x179y221z',
                118: '-94x86y271z',
                119: '-98x194y206z',
                120: '-9x2y299z',
                121: '-9x88y286z',
                122: '0x0y299z'}


shot2five4004xi = {
                1: '-100x124y366z',
                2: '-102x266y280z',
                3: '-102x361y136z',
                4: '-109x121y364z',
                5: '-111x243y297z',
                6: '-117x118y363z',
                7: '-117x263y277z',
                8: '-121x357y133z',
                9: '-125x239y294z',
                10: '-126x114y361z',
                11: '-12x118y381z',
                12: '-12x2y399z',
                13: '-131x259y274z',
                14: '-135x110y359z',
                15: '-139x235y291z',
                16: '-140x351y129z',
                17: '-143x105y358z',
                18: '-146x254y271z',
                19: '-152x99y356z',
                20: '-153x229y289z',
                21: '-159x344y125z',
                22: '-160x93y354z',
                23: '-161x248y268z',
                24: '-166x223y286z',
                25: '-167x86y352z',
                26: '-16x2y399z',
                27: '-175x241y265z',
                28: '-175x78y350z',
                29: '-177x337y121z',
                30: '-180x216y283z',
                31: '-182x70y348z',
                32: '-189x234y262z',
                33: '-189x62y346z',
                34: '-18x121y380z',
                35: '-193x209y280z',
                36: '-195x328y117z',
                37: '-195x53y344z',
                38: '-201x43y342z',
                39: '-203x225y259z',
                40: '-205x200y277z',
                41: '-206x33y340z',
                42: '-20x2y399z',
                43: '-211x22y338z',
                44: '-213x318y114z',
                45: '-216x12y336z',
                46: '-216x216y256z',
                47: '-218x191y275z',
                48: '-219x0y334z',
                49: '-229x206y253z',
                50: '-230x181y272z',
                51: '-230x307y110z',
                52: '-241x170y269z',
                53: '-242x196y250z',
                54: '-246x296y106z',
                55: '-24x1y399z',
                56: '-252x159y266z',
                57: '-254x184y247z',
                58: '-25x123y379z',
                59: '-262x147y263z',
                60: '-262x283y102z',
                61: '-265x172y244z',
                62: '-272x134y260z',
                63: '-276x159y241z',
                64: '-277x270y98z',
                65: '-281x121y257z',
                66: '-286x145y237z',
                67: '-289x107y254z',
                68: '-28x0y398z',
                69: '-28x269y294z',
                70: '-292x256y94z',
                71: '-295x131y234z',
                72: '-297x92y250z',
                73: '-304x116y231z',
                74: '-304x77y247z',
                75: '-306x241y90z',
                76: '-310x61y244z',
                77: '-312x101y228z',
                78: '-315x45y241z',
                79: '-318x225y87z',
                80: '-319x29y238z',
                81: '-319x85y224z',
                82: '-323x12y235z',
                83: '-325x69y221z',
                84: '-331x208y83z',
                85: '-331x52y218z',
                86: '-335x35y214z',
                87: '-339x17y211z',
                88: '-33x125y378z',
                89: '-341x0y208z',
                90: '-342x191y79z',
                91: '-352x173y75z',
                92: '-361x155y71z',
                93: '-369x136y67z',
                94: '-377x116y63z',
                95: '-383x97y59z',
                96: '-388x77y55z',
                97: '-392x56y51z',
                98: '-395x36y47z',
                99: '-397x15y43z',
                100: '-40x127y376z',
                101: '-42x248y310z',
                102: '-42x270y291z',
                103: '-43x368y148z',
                104: '-48x128y375z',
                105: '-4x1y399z',
                106: '-56x249y307z',
                107: '-57x129y374z',
                108: '-57x270y288z',
                109: '-63x367y144z',
                110: '-65x129y372z',
                111: '-69x248y305z',
                112: '-72x269y286z',
                113: '-74x129y371z',
                114: '-82x128y369z',
                115: '-82x365y140z',
                116: '-83x247y302z',
                117: '-87x268y283z',
                118: '-8x2y399z',
                119: '-91x126y368z',
                120: '-92x491y9z',
                121: '-97x245y300z',
                122: '0x0y399z'}

shot2five5004xi = {
                1: '-103x160y462z',
                2: '-103x456y175z',
                3: '-104x309y378z',
                4: '-109x335y354z',
                5: '-10x2y499z',
                6: '-114x158y460z',
                7: '-122x307y375z',
                8: '-125x155y458z',
                9: '-127x332y350z',
                10: '-127x452y171z',
                11: '-136x152y456z',
                12: '-139x303y371z',
                13: '-146x328y347z',
                14: '-147x148y454z',
                15: '-151x446y166z',
                16: '-157x299y368z',
                17: '-158x143y452z',
                18: '-15x147y477z',
                19: '-15x3y499z',
                20: '-164x323y343z',
                21: '-169x137y449z',
                22: '-174x293y364z',
                23: '-175x439y161z',
                24: '-179x131y447z',
                25: '-183x317y339z',
                26: '-190x124y445z',
                27: '-191x287y361z',
                28: '-198x431y156z',
                29: '-1x0y499z',
                30: '-200x116y443z',
                31: '-201x310y336z',
                32: '-208x279y358z',
                33: '-209x107y440z',
                34: '-20x3y499z',
                35: '-219x302y332z',
                36: '-219x98y438z',
                37: '-221x421y152z',
                38: '-225x271y354z',
                39: '-228x88y436z',
                40: '-236x77y433z',
                41: '-237x292y328z',
                42: '-23x151y475z',
                43: '-241x261y351z',
                44: '-244x410y147z',
                45: '-244x66y431z',
                46: '-251x54y428z',
                47: '-254x282y324z',
                48: '-257x251y347z',
                49: '-258x41y425z',
                50: '-264x28y423z',
                51: '-266x398y142z',
                52: '-26x2y499z',
                53: '-270x15y420z',
                54: '-271x271y321z',
                55: '-272x239y343z',
                56: '-274x0y417z',
                57: '-287x227y340z',
                58: '-287x258y317z',
                59: '-287x384y137z',
                60: '-301x213y336z',
                61: '-302x245y313z',
                62: '-308x370y133z',
                63: '-315x199y332z',
                64: '-317x230y309z',
                65: '-31x1y499z',
                66: '-328x184y329z',
                67: '-328x354y128z',
                68: '-32x154y474z',
                69: '-331x215y305z',
                70: '-340x168y325z',
                71: '-345x199y301z',
                72: '-347x337y123z',
                73: '-351x151y321z',
                74: '-358x182y297z',
                75: '-35x336y368z',
                76: '-362x133y317z',
                77: '-365x320y118z',
                78: '-369x164y293z',
                79: '-36x0y498z',
                80: '-371x115y313z',
                81: '-380x146y289z',
                82: '-380x96y309z',
                83: '-382x301y113z',
                84: '-387x77y305z',
                85: '-390x126y285z',
                86: '-394x57y301z',
                87: '-398x281y108z',
                88: '-399x107y281z',
                89: '-399x37y297z',
                90: '-407x86y277z',
                91: '-413x260y103z',
                92: '-413x65y272z',
                93: '-419x44y268z',
                94: '-41x157y472z',
                95: '-423x22y264z',
                96: '-426x0y260z',
                97: '-427x239y98z',
                98: '-440x216y94z',
                99: '-452x194y89z',
                100: '-462x170y84z',
                101: '-471x146y79z',
                102: '-479x121y74z',
                103: '-485x19y352z',
                104: '-485x96y69z',
                105: '-490x70y64z',
                106: '-494x45y59z',
                107: '-496x19y54z',
                108: '-51x159y471z',
                109: '-53x310y387z',
                110: '-53x337y364z',
                111: '-54x461y185z',
                112: '-5x1y499z',
                113: '-61x160y469z',
                114: '-70x311y384z',
                115: '-71x161y467z',
                116: '-71x338y361z',
                117: '-79x459y180z',
                118: '-81x161y465z',
                119: '-87x311y381z',
                120: '-90x337y357z',
                121: '-92x161y464z'}

shot2five6004xi = {
                1: '-104x373y457z',
                2: '-108x404y429z',
                3: '-111x193y556z',
                4: '-124x192y554z',
                5: '-124x547y210z',
                6: '-125x371y454z',
                7: '-130x402y425z',
                8: '-137x190y552z',
                9: '-13x3y599z',
                10: '-146x368y450z',
                11: '-150x186y549z',
                12: '-153x399y420z',
                13: '-153x542y205z',
                14: '-163x182y547z',
                15: '-167x364y446z',
                16: '-175x394y416z',
                17: '-176x177y545z',
                18: '-182x535y199z',
                19: '-188x359y442z',
                20: '-189x172y542z',
                21: '-18x177y572z',
                22: '-197x388y412z',
                23: '-19x4y599z',
                24: '-1x0y599z',
                25: '-202x165y539z',
                26: '-209x352y437z',
                27: '-210x527y194z',
                28: '-215x157y537z',
                29: '-220x381y407z',
                30: '-228x149y534z',
                31: '-230x344y433z',
                32: '-238x517y188z',
                33: '-240x139y531z',
                34: '-241x372y403z',
                35: '-250x335y429z',
                36: '-251x129y528z',
                37: '-25x4y599z',
                38: '-263x118y526z',
                39: '-263x362y398z',
                40: '-266x505y182z',
                41: '-270x325y425z',
                42: '-273x106y523z',
                43: '-283x93y520z',
                44: '-284x351y394z',
                45: '-289x313y421z',
                46: '-28x181y571z',
                47: '-293x492y176z',
                48: '-293x79y517z',
                49: '-302x65y514z',
                50: '-305x338y389z',
                51: '-308x301y416z',
                52: '-310x50y511z',
                53: '-317x34y507z',
                54: '-319x478y171z',
                55: '-31x3y599z',
                56: '-324x18y504z',
                57: '-325x325y385z',
                58: '-327x287y412z',
                59: '-329x1y501z',
                60: '-344x310y380z',
                61: '-345x272y408z',
                62: '-345x461y165z',
                63: '-362x256y403z',
                64: '-363x294y375z',
                65: '-370x444y159z',
                66: '-378x239y399z',
                67: '-37x2y598z',
                68: '-381x277y371z',
                69: '-38x185y569z',
                70: '-393x425y153z',
                71: '-394x221y394z',
                72: '-398x258y366z',
                73: '-408x201y390z',
                74: '-414x239y361z',
                75: '-416x405y148z',
                76: '-422x181y385z',
                77: '-429x218y356z',
                78: '-42x403y441z',
                79: '-434x160y381z',
                80: '-438x384y142z',
                81: '-43x0y598z',
                82: '-443x197y352z',
                83: '-446x138y376z',
                84: '-456x116y371z',
                85: '-456x175y347z',
                86: '-459x361y136z',
                87: '-465x92y367z',
                88: '-468x152y342z',
                89: '-473x68y362z',
                90: '-478x337y130z',
                91: '-479x128y337z',
                92: '-479x44y357z',
                93: '-488x103y332z',
                94: '-496x312y124z',
                95: '-496x78y327z',
                96: '-49x188y567z',
                97: '-503x52y322z',
                98: '-508x26y317z',
                99: '-512x0y312z',
                100: '-513x287y118z',
                101: '-528x260y112z',
                102: '-542x232y107z',
                103: '-554x204y101z',
                104: '-565x175y95z',
                105: '-565x22y411z',
                106: '-575x145y89z',
                107: '-582x115y83z',
                108: '-588x85y77z',
                109: '-593x54y71z',
                110: '-595x23y65z',
                111: '-61x191y565z',
                112: '-63x373y465z',
                113: '-64x405y437z',
                114: '-65x553y222z',
                115: '-73x193y563z',
                116: '-7x2y599z',
                117: '-84x373y461z',
                118: '-85x194y561z',
                119: '-86x405y433z',
                120: '-95x551y216z',
                121: '-98x194y559z'}

shot2five7004xi = {
                1: '-100x473y505z',
                2: '-110x643y252z',
                3: '-114x226y652z',
                4: '-122x435y534z',
                5: '-126x472y500z',
                6: '-129x226y649z',
                7: '-144x224y647z',
                8: '-144x639y246z',
                9: '-146x433y529z',
                10: '-152x469y495z',
                11: '-15x4y699z',
                12: '-160x221y644z',
                13: '-171x430y525z',
                14: '-175x218y641z',
                15: '-178x465y490z',
                16: '-178x632y239z',
                17: '-190x213y638z',
                18: '-195x425y520z',
                19: '-1x0y699z',
                20: '-204x460y485z',
                21: '-206x207y635z',
                22: '-212x624y232z',
                23: '-21x206y668z',
                24: '-220x419y515z',
                25: '-221x200y632z',
                26: '-22x4y699z',
                27: '-230x453y480z',
                28: '-236x192y629z',
                29: '-244x411y510z',
                30: '-245x615y226z',
                31: '-251x184y626z',
                32: '-256x444y475z',
                33: '-266x174y623z',
                34: '-268x402y506z',
                35: '-278x603y219z',
                36: '-280x162y620z',
                37: '-282x434y470z',
                38: '-292x391y501z',
                39: '-293x150y617z',
                40: '-29x4y699z',
                41: '-306x137y613z',
                42: '-307x423y465z',
                43: '-310x589y213z',
                44: '-315x379y496z',
                45: '-319x123y610z',
                46: '-32x211y666z',
                47: '-331x108y606z',
                48: '-332x409y460z',
                49: '-338x366y491z',
                50: '-342x574y206z',
                51: '-342x92y603z',
                52: '-352x76y599z',
                53: '-356x395y454z',
                54: '-360x351y486z',
                55: '-362x58y596z',
                56: '-36x4y699z',
                57: '-370x40y592z',
                58: '-372x557y199z',
                59: '-378x21y588z',
                60: '-379x379y449z',
                61: '-381x335y481z',
                62: '-384x1y584z',
                63: '-402x317y476z',
                64: '-402x362y444z',
                65: '-402x538y192z',
                66: '-422x299y471z',
                67: '-423x343y438z',
                68: '-431x518y186z',
                69: '-43x2y698z',
                70: '-441x279y465z',
                71: '-444x323y433z',
                72: '-459x257y460z',
                73: '-459x496y179z',
                74: '-45x216y664z',
                75: '-464x301y427z',
                76: '-476x235y455z',
                77: '-483x279y422z',
                78: '-486x473y172z',
                79: '-492x212y450z',
                80: '-49x471y515z',
                81: '-501x255y416z',
                82: '-507x187y444z',
                83: '-50x0y698z',
                84: '-511x448y165z',
                85: '-517x230y410z',
                86: '-520x162y439z',
                87: '-532x135y433z',
                88: '-532x204y405z',
                89: '-535x421y159z',
                90: '-543x108y428z',
                91: '-546x177y399z',
                92: '-552x80y422z',
                93: '-558x394y152z',
                94: '-559x149y393z',
                95: '-559x51y417z',
                96: '-570x121y387z',
                97: '-579x365y145z',
                98: '-579x91y381z',
                99: '-587x61y376z',
                100: '-58x220y661z',
                101: '-593x31y370z',
                102: '-597x0y364z',
                103: '-598x334y138z',
                104: '-616x303y131z',
                105: '-632x271y124z',
                106: '-646x25y470z',
                107: '-647x238y117z',
                108: '-660x204y111z',
                109: '-670x170y104z',
                110: '-679x134y97z',
                111: '-687x99y90z',
                112: '-692x63y83z',
                113: '-695x27y76z',
                114: '-71x223y659z',
                115: '-74x435y543z',
                116: '-74x473y510z',
                117: '-76x645y259z',
                118: '-85x225y657z',
                119: '-8x2y699z',
                120: '-98x435y538z',
                121: '-99x226y654z'}

shot2five8004xi = {
                1: '-112x498y615z',
                2: '-114x258y748z',
                3: '-115x541y577z',
                4: '-126x735y288z',
                5: '-131x259y745z',
                6: '-139x497y610z',
                7: '-144x539y572z',
                8: '-148x258y742z',
                9: '-165x256y739z',
                10: '-165x730y281z',
                11: '-167x495y605z',
                12: '-174x537y566z',
                13: '-17x4y799z',
                14: '-182x253y736z',
                15: '-195x491y600z',
                16: '-1x0y799z',
                17: '-200x249y733z',
                18: '-204x532y561z',
                19: '-204x723y273z',
                20: '-218x243y729z',
                21: '-223x486y594z',
                22: '-234x526y555z',
                23: '-235x237y726z',
                24: '-242x714y266z',
                25: '-24x236y763z',
                26: '-251x478y589z',
                27: '-253x229y723z',
                28: '-25x5y799z',
                29: '-263x518y549z',
                30: '-270x220y719z',
                31: '-279x470y583z',
                32: '-280x702y258z',
                33: '-287x210y716z',
                34: '-293x508y543z',
                35: '-304x198y712z',
                36: '-306x459y578z',
                37: '-318x689y251z',
                38: '-320x186y709z',
                39: '-322x496y537z',
                40: '-333x447y572z',
                41: '-335x172y705z',
                42: '-33x5y799z',
                43: '-350x157y701z',
                44: '-351x483y531z',
                45: '-355x674y243z',
                46: '-360x433y567z',
                47: '-365x141y697z',
                48: '-378x124y693z',
                49: '-379x468y525z',
                50: '-37x242y761z',
                51: '-386x418y561z',
                52: '-391x106y689z',
                53: '-391x656y235z',
                54: '-403x87y685z',
                55: '-406x451y519z',
                56: '-411x401y555z',
                57: '-413x66y681z',
                58: '-41x4y798z',
                59: '-423x45y677z',
                60: '-426x637y228z',
                61: '-432x24y672z',
                62: '-433x433y513z',
                63: '-436x383y550z',
                64: '-439x1y668z',
                65: '-459x413y507z',
                66: '-460x363y544z',
                67: '-460x615y220z',
                68: '-482x341y538z',
                69: '-484x392y501z',
                70: '-493x592y212z',
                71: '-49x2y798z',
                72: '-504x318y532z',
                73: '-508x369y495z',
                74: '-51x247y759z',
                75: '-525x294y526z',
                76: '-525x567y205z',
                77: '-531x344y488z',
                78: '-544x269y520z',
                79: '-552x319y482z',
                80: '-555x540y197z',
                81: '-562x242y514z',
                82: '-56x538y588z',
                83: '-572x291y475z',
                84: '-579x214y508z',
                85: '-57x0y797z',
                86: '-584x512y189z',
                87: '-591x263y469z',
                88: '-594x185y501z',
                89: '-608x155y495z',
                90: '-609x233y463z',
                91: '-612x482y181z',
                92: '-620x123y489z',
                93: '-624x203y456z',
                94: '-631x91y483z',
                95: '-637x450y174z',
                96: '-638x171y449z',
                97: '-639x59y476z',
                98: '-651x138y443z',
                99: '-662x104y436z',
                100: '-662x417y166z',
                101: '-66x251y756z',
                102: '-671x70y429z',
                103: '-678x35y423z',
                104: '-683x0y416z',
                105: '-684x382y158z',
                106: '-704x347y150z',
                107: '-723x310y142z',
                108: '-727x29y528z',
                109: '-739x272y134z',
                110: '-754x233y126z',
                111: '-766x194y119z',
                112: '-777x154y111z',
                113: '-785x113y103z',
                114: '-791x72y95z',
                115: '-794x30y87z',
                116: '-81x255y753z',
                117: '-85x497y620z',
                118: '-85x540y583z',
                119: '-87x737y296z',
                120: '-97x257y751z',
                121: '-9x3y799z'}

shot2five9004xi = {
                1: '-10x3y899z',
                2: '-110x289y844z',
                3: '-126x560y692z',
                4: '-128x291y841z',
                5: '-129x608y650z',
                6: '-142x827y324z',
                7: '-147x291y838z',
                8: '-157x559y686z',
                9: '-162x607y643z',
                10: '-166x290y835z',
                11: '-186x288y831z',
                12: '-186x821y316z',
                13: '-188x557y681z',
                14: '-196x604y637z',
                15: '-19x5y899z',
                16: '-205x285y828z',
                17: '-220x552y675z',
                18: '-225x280y824z',
                19: '-229x598y631z',
                20: '-229x813y308z',
                21: '-245x274y821z',
                22: '-251x546y669z',
                23: '-263x591y624z',
                24: '-265x266y817z',
                25: '-273x803y299z',
                26: '-27x265y859z',
                27: '-282x538y663z',
                28: '-284x258y813z',
                29: '-28x6y899z',
                30: '-296x582y618z',
                31: '-2x0y899z',
                32: '-304x248y809z',
                33: '-314x528y656z',
                34: '-315x790y291z',
                35: '-323x236y805z',
                36: '-330x571y611z',
                37: '-342x223y801z',
                38: '-345x517y650z',
                39: '-358x775y282z',
                40: '-360x209y797z',
                41: '-362x558y604z',
                42: '-375x503y644z',
                43: '-377x194y793z',
                44: '-37x6y899z',
                45: '-394x177y789z',
                46: '-395x543y598z',
                47: '-399x758y273z',
                48: '-405x488y638z',
                49: '-410x159y784z',
                50: '-425x139y780z',
                51: '-426x527y591z',
                52: '-42x272y856z',
                53: '-434x470y631z',
                54: '-440x119y775z',
                55: '-440x738y265z',
                56: '-453x97y771z',
                57: '-457x508y584z',
                58: '-463x451y625z',
                59: '-465x75y766z',
                60: '-46x5y898z',
                61: '-476x51y761z',
                62: '-479x717y256z',
                63: '-486x27y756z',
                64: '-487x487y577z',
                65: '-490x431y618z',
                66: '-494x1y752z',
                67: '-517x408y612z',
                68: '-517x465y570z',
                69: '-517x692y248z',
                70: '-543x384y605z',
                71: '-545x441y563z',
                72: '-555x666y239z',
                73: '-567x358y599z',
                74: '-56x3y898z',
                75: '-571x415y556z',
                76: '-58x278y853z',
                77: '-590x638y230z',
                78: '-591x331y592z',
                79: '-597x388y549z',
                80: '-612x302y585z',
                81: '-621x358y542z',
                82: '-625x608y222z',
                83: '-633x272y578z',
                84: '-63x605y662z',
                85: '-644x328y535z',
                86: '-651x241y571z',
                87: '-657x576y213z',
                88: '-65x0y897z',
                89: '-665x296y528z',
                90: '-669x208y564z',
                91: '-684x174y557z',
                92: '-685x263y520z',
                93: '-688x542y204z',
                94: '-698x139y550z',
                95: '-702x228y513z',
                96: '-709x103y543z',
                97: '-717x506y195z',
                98: '-718x192y506z',
                99: '-719x66y536z',
                100: '-732x155y498z',
                101: '-744x117y491z',
                102: '-744x469y187z',
                103: '-74x283y851z',
                104: '-754x79y483z',
                105: '-762x39y475z',
                106: '-768x0y468z',
                107: '-769x430y178z',
                108: '-792x390y169z',
                109: '-808x32y587z',
                110: '-813x349y160z',
                111: '-832x306y151z',
                112: '-848x263y142z',
                113: '-862x218y133z',
                114: '-874x173y124z',
                115: '-883x127y116z',
                116: '-889x81y107z',
                117: '-893x34y98z',
                118: '-92x286y848z',
                119: '-95x559y698z',
                120: '-96x608y656z',
                121: '-98x830y333z'}                         


shot2five10004xi = {
                1: '-102x318y942z',
                2: '-106x621y775z',
                3: '-107x675y729z',
                4: '-109x922y370z',
                5: '-11x3y999z',
                6: '-122x321y938z',
                7: '-140x622y769z',
                8: '-142x323y935z',
                9: '-143x676y722z',
                10: '-158x919y360z',
                11: '-163x323y931z',
                12: '-174x622y763z',
                13: '-180x674y715z',
                14: '-185x323y928z',
                15: '-206x320y924z',
                16: '-207x912y351z',
                17: '-209x619y756z',
                18: '-218x671y708z',
                19: '-21x5y999z',
                20: '-228x316y920z',
                21: '-244x614y750z',
                22: '-250x311y916z',
                23: '-255x665y701z',
                24: '-255x904y342z',
                25: '-272x304y912z',
                26: '-279x607y743z',
                27: '-292x657y694z',
                28: '-294x296y908z',
                29: '-2x0y999z',
                30: '-303x892y332z',
                31: '-30x295y954z',
                32: '-314x598y736z',
                33: '-316x286y904z',
                34: '-31x6y999z',
                35: '-329x647y686z',
                36: '-338x275y899z',
                37: '-349x587y729z',
                38: '-351x878y323z',
                39: '-359x262y895z',
                40: '-366x635y679z',
                41: '-380x248y890z',
                42: '-383x574y723z',
                43: '-397x862y313z',
                44: '-400x232y886z',
                45: '-403x620y672z',
                46: '-417x559y716z',
                47: '-419x215y881z',
                48: '-41x6y999z',
                49: '-438x196y876z',
                50: '-439x604y664z',
                51: '-443x842y304z',
                52: '-450x542y709z',
                53: '-456x176y872z',
                54: '-46x302y951z',
                55: '-473x155y867z',
                56: '-474x585y657z',
                57: '-483x523y702z',
                58: '-488x820y294z',
                59: '-489x132y862z',
                60: '-503x108y856z',
                61: '-508x564y649z',
                62: '-514x502y694z',
                63: '-517x83y851z',
                64: '-529x57y846z',
                65: '-52x5y998z',
                66: '-532x796y285z',
                67: '-540x30y841z',
                68: '-542x542y642z',
                69: '-545x479y687z',
                70: '-549x1y835z',
                71: '-574x517y634z',
                72: '-575x454y680z',
                73: '-575x769y275z',
                74: '-603x427y673z',
                75: '-605x490y626z',
                76: '-616x740y266z',
                77: '-62x3y998z',
                78: '-630x398y665z',
                79: '-635x461y618z',
                80: '-64x309y948z',
                81: '-656x368y658z',
                82: '-656x709y256z',
                83: '-663x431y610z',
                84: '-680x336y650z',
                85: '-690x398y602z',
                86: '-694x675y246z',
                87: '-703x302y642z',
                88: '-70x673y736z',
                89: '-716x364y594z',
                90: '-724x267y635z',
                91: '-72x0y997z',
                92: '-730x640y237z',
                93: '-739x329y586z',
                94: '-743x231y627z',
                95: '-760x193y619z',
                96: '-761x292y578z',
                97: '-765x602y227z',
                98: '-775x154y611z',
                99: '-781x253y570z',
                100: '-788x114y603z',
                101: '-797x562y217z',
                102: '-798x214y562z',
                103: '-799x74y595z',
                104: '-814x173y554z',
                105: '-827x131y545z',
                106: '-827x521y207z',
                107: '-838x88y537z',
                108: '-83x314y945z',
                109: '-847x44y528z',
                110: '-853x0y520z',
                111: '-855x478y197z',
                112: '-881x433y188z',
                113: '-889x35y646z',
                114: '-904x388y178z',
                115: '-924x340y168z',
                116: '-943x292y158z',
                117: '-958x242y148z',
                118: '-971x192y138z',
                119: '-981x141y128z',
                120: '-988x90y119z',
                121: '-993x38y109z'}                       


shot2five11004xi = {
                1: '-1017x374y185z',
                2: '-1037x321y174z',
                3: '-1054x267y163z',
                4: '-1068x212y152z',
                5: '-1079x156y141z',
                6: '-1087x99y130z',
                7: '-1092x42y120z',
                8: '-112x350y1036z',
                9: '-117x683y853z',
                10: '-117x743y802z',
                11: '-120x1014y407z',
                12: '-134x353y1032z',
                13: '-13x4y1099z',
                14: '-154x685y846z',
                15: '-157x355y1028z',
                16: '-158x744y794z',
                17: '-174x1010y397z',
                18: '-180x356y1024z',
                19: '-192x684y839z',
                20: '-198x742y786z',
                21: '-203x355y1020z',
                22: '-227x1004y386z',
                23: '-227x352y1016z',
                24: '-230x681y832z',
                25: '-239x738y779z',
                26: '-23x6y1099z',
                27: '-251x348y1012z',
                28: '-269x675y825z',
                29: '-275x342y1008z',
                30: '-281x732y771z',
                31: '-281x994y376z',
                32: '-2x1y1099z',
                33: '-300x335y1003z',
                34: '-307x668y817z',
                35: '-322x723y763z',
                36: '-324x326y999z',
                37: '-333x982y366z',
                38: '-33x324y1050z',
                39: '-345x658y810z',
                40: '-348x315y994z',
                41: '-34x7y1099z',
                42: '-362x712y755z',
                43: '-372x303y989z',
                44: '-383x646y802z',
                45: '-386x966y355z',
                46: '-395x289y984z',
                47: '-403x698y747z',
                48: '-418x273y979z',
                49: '-421x632y795z',
                50: '-437x948y345z',
                51: '-440x256y974z',
                52: '-443x683y739z',
                53: '-458x615y787z',
                54: '-461x237y969z',
                55: '-46x7y1099z',
                56: '-482x216y964z',
                57: '-483x664y731z',
                58: '-488x927y334z',
                59: '-495x596y780z',
                60: '-502x194y959z',
                61: '-51x333y1047z',
                62: '-520x170y953z',
                63: '-521x644y723z',
                64: '-531x575y772z',
                65: '-537x903y324z',
                66: '-538x146y948z',
                67: '-554x119y942z',
                68: '-559x621y714z',
                69: '-566x552y764z',
                70: '-568x91y936z',
                71: '-57x6y1098z',
                72: '-582x63y931z',
                73: '-586x876y313z',
                74: '-594x33y925z',
                75: '-596x596y706z',
                76: '-600x527y756z',
                77: '-604x1y919z',
                78: '-631x568y697z',
                79: '-632x499y748z',
                80: '-633x846y303z',
                81: '-664x470y740z',
                82: '-666x539y689z',
                83: '-678x814y292z',
                84: '-68x3y1097z',
                85: '-693x438y732z',
                86: '-699x507y680z',
                87: '-71x340y1043z',
                88: '-722x405y723z',
                89: '-722x780y282z',
                90: '-730x474y671z',
                91: '-749x370y715z',
                92: '-759x438y663z',
                93: '-763x743y271z',
                94: '-773x333y707z',
                95: '-77x740y809z',
                96: '-787x401y654z',
                97: '-796x294y698z',
                98: '-79x0y1097z',
                99: '-803x704y260z',
                100: '-813x362y645z',
                101: '-817x254y690z',
                102: '-836x213y681z',
                103: '-837x321y636z',
                104: '-841x662y250z',
                105: '-853x170y672z',
                106: '-859x279y627z',
                107: '-867x126y664z',
                108: '-877x619y239z',
                109: '-878x235y618z',
                110: '-879x81y655z',
                111: '-895x190y609z',
                112: '-910x144y600z',
                113: '-910x573y228z',
                114: '-91x346y1040z',
                115: '-922x96y590z',
                116: '-932x48y581z',
                117: '-939x0y572z',
                118: '-940x526y217z',
                119: '-969x477y207z',
                120: '-970x38y705z',
                121: '-994x426y196z'}

shot2five12004xi = {
                1: '-1006x105y644z',
                2: '-1017x53y634z',
                3: '-1024x0y624z',
                4: '-1026x574y237z',
                5: '-1050x42y764z',
                6: '-1057x520y225z',
                7: '-1085x465y214z',
                8: '-1109x408y202z',
                9: '-1131x350y190z',
                10: '-1150x291y178z',
                11: '-1165x231y166z',
                12: '-1177x170y154z',
                13: '-1186x108y142z',
                14: '-1191x46y130z',
                15: '-122x382y1130z',
                16: '-127x746y931z',
                17: '-128x811y875z',
                18: '-131x1106y444z',
                19: '-146x386y1126z',
                20: '-14x4y1199z',
                21: '-168x747y923z',
                22: '-171x388y1122z',
                23: '-172x811y866z',
                24: '-190x1102y433z',
                25: '-196x388y1118z',
                26: '-209x746y915z',
                27: '-217x809y858z',
                28: '-222x387y1113z',
                29: '-248x1095y421z',
                30: '-248x384y1109z',
                31: '-251x743y908z',
                32: '-261x805y850z',
                33: '-26x7y1199z',
                34: '-274x380y1104z',
                35: '-293x737y900z',
                36: '-2x1y1199z',
                37: '-300x373y1099z',
                38: '-306x1085y410z',
                39: '-306x798y841z',
                40: '-327x365y1094z',
                41: '-335x729y892z',
                42: '-351x789y832z',
                43: '-353x355y1090z',
                44: '-364x1071y399z',
                45: '-36x354y1145z',
                46: '-377x718y884z',
                47: '-379x344y1084z',
                48: '-38x8y1199z',
                49: '-395x777y824z',
                50: '-405x330y1079z',
                51: '-418x705y875z',
                52: '-421x1054y388z',
                53: '-431x315y1074z',
                54: '-440x762y815z',
                55: '-456x298y1069z',
                56: '-460x689y867z',
                57: '-477x1034y376z',
                58: '-480x279y1063z',
                59: '-483x745y806z',
                60: '-500x671y859z',
                61: '-503x258y1057z',
                62: '-50x8y1198z',
                63: '-526x236y1052z',
                64: '-526x725y797z',
                65: '-532x1011y365z',
                66: '-540x650y850z',
                67: '-547x212y1046z',
                68: '-567x186y1040z',
                69: '-569x702y788z',
                70: '-56x363y1142z',
                71: '-579x627y842z',
                72: '-586x159y1034z',
                73: '-586x985y353z',
                74: '-604x130y1028z',
                75: '-610x677y779z',
                76: '-617x602y833z',
                77: '-620x100y1022z',
                78: '-62x6y1198z',
                79: '-635x68y1015z',
                80: '-639x956y342z',
                81: '-648x36y1009z',
                82: '-650x650y770z',
                83: '-654x574y825z',
                84: '-659x2y1002z',
                85: '-689x620y761z',
                86: '-690x544y816z',
                87: '-690x923y330z',
                88: '-724x512y807z',
                89: '-726x588y751z',
                90: '-740x889y319z',
                91: '-74x4y1197z',
                92: '-757x478y798z',
                93: '-762x554y742z',
                94: '-77x371y1138z',
                95: '-787x851y307z',
                96: '-788x442y789z',
                97: '-796x517y733z',
                98: '-817x403y780z',
                99: '-829x478y723z',
                100: '-833x811y296z',
                101: '-844x363y771z',
                102: '-84x807y883z',
                103: '-859x437y713z',
                104: '-869x321y762z',
                105: '-86x0y1196z',
                106: '-876x768y284z',
                107: '-887x395y704z',
                108: '-892x277y752z',
                109: '-912x232y743z',
                110: '-913x350y694z',
                111: '-918x723y272z',
                112: '-930x185y734z',
                113: '-937x304y684z',
                114: '-946x137y724z',
                115: '-956x675y261z',
                116: '-958x256y674z',
                117: '-959x88y714z',
                118: '-977x207y664z',
                119: '-993x157y654z',
                120: '-993x625y249z',
                121: '-99x377y1134z'}

shot2five13004xi = {
                1: '-1008x201y795z',
                2: '-1015x329y741z',
                3: '-1025x149y784z',
                4: '-1036x731y282z',
                5: '-1038x278y731z',
                6: '-1039x96y774z',
                7: '-1058x225y720z',
                8: '-1075x170y709z',
                9: '-1075x678y270z',
                10: '-108x409y1229z',
                11: '-1090x114y698z',
                12: '-1101x57y687z',
                13: '-1110x0y676z',
                14: '-1112x622y257z',
                15: '-1131x45y822z',
                16: '-1145x564y244z',
                17: '-1175x504y231z',
                18: '-1202x442y219z',
                19: '-1225x380y206z',
                20: '-1246x315y193z',
                21: '-1262x250y180z',
                22: '-1275x184y167z',
                23: '-1285x117y154z',
                24: '-1291x50y141z',
                25: '-133x414y1224z',
                26: '-138x808y1008z',
                27: '-139x878y948z',
                28: '-142x1199y481z',
                29: '-159x418y1220z',
                30: '-15x5y1299z',
                31: '-182x809y1000z',
                32: '-185x420y1215z',
                33: '-186x879y939z',
                34: '-205x1194y469z',
                35: '-212x421y1211z',
                36: '-227x808y992z',
                37: '-235x877y930z',
                38: '-240x419y1206z',
                39: '-268x416y1201z',
                40: '-269x1186y457z',
                41: '-272x804y983z',
                42: '-283x872y920z',
                43: '-28x7y1299z',
                44: '-297x411y1196z',
                45: '-317x798y975z',
                46: '-325x405y1191z',
                47: '-332x1175y444z',
                48: '-332x865y911z',
                49: '-354x396y1186z',
                50: '-363x789y966z',
                51: '-380x854y902z',
                52: '-383x385y1180z',
                53: '-394x1160y432z',
                54: '-39x384y1241z',
                55: '-3x1y1299z',
                56: '-408x778y957z',
                57: '-411x372y1175z',
                58: '-41x8y1299z',
                59: '-428x841y892z',
                60: '-439x358y1169z',
                61: '-453x763y948z',
                62: '-456x1142y420z',
                63: '-467x341y1164z',
                64: '-476x825y883z',
                65: '-494x323y1158z',
                66: '-498x747y940z',
                67: '-517x1120y408z',
                68: '-520x302y1152z',
                69: '-524x807y873z',
                70: '-542x727y930z',
                71: '-545x280y1146z',
                72: '-54x8y1298z',
                73: '-570x256y1139z',
                74: '-570x785y864z',
                75: '-577x1095y395z',
                76: '-585x705y921z',
                77: '-593x229y1133z',
                78: '-615x202y1127z',
                79: '-616x761y854z',
                80: '-61x393y1237z',
                81: '-627x680y912z',
                82: '-635x1067y383z',
                83: '-635x172y1120z',
                84: '-654x141y1114z',
                85: '-661x734y844z',
                86: '-669x652y903z',
                87: '-672x108y1107z',
                88: '-67x7y1298z',
                89: '-688x74y1100z',
                90: '-692x1035y370z',
                91: '-702x39y1093z',
                92: '-704x704y834z',
                93: '-709x622y893z',
                94: '-714x2y1086z',
                95: '-746x672y824z',
                96: '-747x590y884z',
                97: '-748x1000y358z',
                98: '-784x555y874z',
                99: '-787x637y814z',
                100: '-801x963y345z',
                101: '-81x4y1297z',
                102: '-820x518y865z',
                103: '-826x600y804z',
                104: '-84x402y1233z',
                105: '-853x478y855z',
                106: '-853x922y333z',
                107: '-863x560y794z',
                108: '-885x437y845z',
                109: '-898x518y783z',
                110: '-902x878y320z',
                111: '-914x393y835z',
                112: '-91x875y956z',
                113: '-931x474y773z',
                114: '-941x348y825z',
                115: '-949x832y308z',
                116: '-94x0y1296z',
                117: '-961x428y762z',
                118: '-966x300y815z',
                119: '-988x251y805z',
                120: '-989x379y752z',
                121: '-994x783y295z'}

shot2five14004xi = {
                1: '-1002x510y832z',
                2: '-1014x374y889z',
                3: '-101x0y1396z',
                4: '-1022x896y331z',
                5: '-1035x461y821z',
                6: '-1040x324y878z',
                7: '-1064x271y867z',
                8: '-1065x409y810z',
                9: '-1071x843y318z',
                10: '-1086x216y856z',
                11: '-1093x355y798z',
                12: '-1104x160y845z',
                13: '-1116x788y304z',
                14: '-1118x299y787z',
                15: '-1119x103y834z',
                16: '-1140x242y775z',
                17: '-1158x183y763z',
                18: '-1158x730y290z',
                19: '-116x440y1323z',
                20: '-1174x123y752z',
                21: '-1186x62y740z',
                22: '-1195x0y728z',
                23: '-1197x669y277z',
                24: '-1212x48y881z',
                25: '-1233x607y263z',
                26: '-1265x543y249z',
                27: '-1294x477y235z',
                28: '-1320x409y222z',
                29: '-1341x340y208z',
                30: '-1359x269y194z',
                31: '-1374x198y180z',
                32: '-1384x126y166z',
                33: '-1390x54y152z',
                34: '-143x446y1319z',
                35: '-148x870y1086z',
                36: '-149x946y1020z',
                37: '-153x1291y518z',
                38: '-16x5y1399z',
                39: '-171x450y1314z',
                40: '-196x871y1077z',
                41: '-199x452y1309z',
                42: '-201x946y1011z',
                43: '-221x1286y505z',
                44: '-229x453y1304z',
                45: '-244x870y1068z',
                46: '-253x944y1001z',
                47: '-259x452y1299z',
                48: '-289x1278y492z',
                49: '-289x448y1294z',
                50: '-293x866y1059z',
                51: '-305x939y991z',
                52: '-30x8y1399z',
                53: '-320x443y1288z',
                54: '-342x860y1050z',
                55: '-351x436y1283z',
                56: '-357x1265y479z',
                57: '-357x931y981z',
                58: '-381x426y1277z',
                59: '-391x850y1040z',
                60: '-3x1y1399z',
                61: '-409x920y971z',
                62: '-412x415y1271z',
                63: '-424x1249y465z',
                64: '-42x413y1336z',
                65: '-440x838y1031z',
                66: '-443x401y1265z',
                67: '-44x9y1399z',
                68: '-461x906y961z',
                69: '-473x385y1259z',
                70: '-488x822y1021z',
                71: '-491x1230y452z',
                72: '-503x368y1253z',
                73: '-513x889y951z',
                74: '-532x348y1247z',
                75: '-536x804y1012z',
                76: '-557x1206y439z',
                77: '-560x325y1240z',
                78: '-564x869y941z',
                79: '-584x783y1002z',
                80: '-587x301y1234z',
                81: '-58x9y1398z',
                82: '-613x275y1227z',
                83: '-614x846y930z',
                84: '-621x1179y426z',
                85: '-630x759y992z',
                86: '-638x247y1220z',
                87: '-65x423y1332z',
                88: '-662x217y1213z',
                89: '-664x819y920z',
                90: '-676x732y982z',
                91: '-684x1149y412z',
                92: '-684x185y1206z',
                93: '-705x152y1199z',
                94: '-712x790y909z',
                95: '-720x703y972z',
                96: '-724x117y1192z',
                97: '-73x8y1398z',
                98: '-741x80y1185z',
                99: '-745x1115y399z',
                100: '-756x42y1177z',
                101: '-758x758y898z',
                102: '-763x670y962z',
                103: '-768x2y1169z',
                104: '-804x724y888z',
                105: '-805x1077y385z',
                106: '-805x635y952z',
                107: '-845x598y942z',
                108: '-847x686y877z',
                109: '-863x1037y372z',
                110: '-87x5y1397z',
                111: '-883x558y931z',
                112: '-889x646y866z',
                113: '-90x432y1328z',
                114: '-919x515y921z',
                115: '-919x993y358z',
                116: '-929x603y855z',
                117: '-953x470y910z',
                118: '-967x558y844z',
                119: '-972x946y345z ',
                120: '-984x424y900z',
                121: '-99x942y1030z'}

shot2five15004xi = {
                1: '-1021x504y975z',
                2: '-1036x598y904z',
                3: '-1041x1013y370z',
                4: '-1055x454y964z',
                5: '-106x1009y1104z',
                6: '-1074x547y892z',
                7: '-1086x401y952z',
                8: '-108x0y1496z',
                9: '-1096x960y355z',
                10: '-1109x493y880z',
                11: '-1115x347y941z',
                12: '-1140x290y929z',
                13: '-1142x438y868z',
                14: '-1147x903y340z',
                15: '-1163x232y917z',
                16: '-1171x380y855z',
                17: '-1183x172y905z',
                18: '-1196x844y326z',
                19: '-1198x321y843z',
                20: '-1199x111y893z',
                21: '-1221x259y831z',
                22: '-1241x196y818z',
                23: '-1241x782y311z',
                24: '-124x471y1418z',
                25: '-1258x132y805z',
                26: '-1271x66y793z',
                27: '-1280x0y780z',
                28: '-1283x717y296z',
                29: '-1293x51y940z',
                30: '-1321x650y282z',
                31: '-1356x582y267z',
                32: '-1387x511y252z',
                33: '-1414x438y237z',
                34: '-1437x364y223z',
                35: '-1457x289y208z',
                36: '-1472x212y193z',
                37: '-1483x135y178z',
                38: '-1489x57y163z',
                39: '-153x478y1413z',
                40: '-159x932y1163z',
                41: '-160x1013y1093z',
                42: '-164x1383y555z',
                43: '-17x5y1499z',
                44: '-183x482y1408z',
                45: '-210x934y1154z',
                46: '-214x485y1403z',
                47: '-215x1014y1083z',
                48: '-237x1378y541z',
                49: '-245x485y1397z',
                50: '-262x933y1144z',
                51: '-271x1012y1073z',
                52: '-277x484y1392z',
                53: '-310x1369y527z',
                54: '-310x480y1386z',
                55: '-314x928y1135z',
                56: '-327x1006y1062z',
                57: '-32x8y1499z',
                58: '-343x475y1380z',
                59: '-366x921y1125z',
                60: '-376x467y1374z',
                61: '-383x1356y513z',
                62: '-383x998y1051z',
                63: '-3x1y1499z',
                64: '-409x457y1368z',
                65: '-419x911y1115z',
                66: '-439x986y1041z',
                67: '-442x444y1362z',
                68: '-455x1339y499z',
                69: '-45x443y1432z',
                70: '-471x897y1105z',
                71: '-474x430y1356z',
                72: '-47x10y1499z',
                73: '-494x971y1030z',
                74: '-507x413y1349z',
                75: '-523x881y1094z',
                76: '-526x1318y485z',
                77: '-539x394y1343z',
                78: '-550x952y1019z',
                79: '-570x372y1336z',
                80: '-575x861y1084z',
                81: '-596x1293y470z',
                82: '-600x349y1329z',
                83: '-604x931y1008z',
                84: '-625x839y1074z',
                85: '-629x323y1322z',
                86: '-62x10y1498z',
                87: '-657x295y1315z',
                88: '-658x906y997z',
                89: '-665x1264y456z',
                90: '-675x813y1063z',
                91: '-684x265y1308z',
                92: '-709x233y1300z',
                93: '-70x454y1427z',
                94: '-711x878y985z',
                95: '-724x784y1053z',
                96: '-733x1231y442z',
                97: '-733x199y1293z',
                98: '-755x163y1285z',
                99: '-762x847y974z',
                100: '-772x753y1042z',
                101: '-775x125y1277z',
                102: '-78x8y1497z',
                103: '-794x86y1269z',
                104: '-799x1195y427z',
                105: '-810x45y1261z',
                106: '-813x813y963z',
                107: '-818x718y1031z',
                108: '-823x2y1253z',
                109: '-861x775y951z',
                110: '-862x681y1020z',
                111: '-863x1154y413z',
                112: '-905x640y1009z',
                113: '-908x735y939z',
                114: '-925x1111y399z',
                115: '-93x5y1497z',
                116: '-946x598y998z',
                117: '-953x692y928z',
                118: '-97x463y1423z',
                119: '-984x1064y384z',
                120: '-985x552y987z',
                121: '-995x646y916z'}

shot2five16004xi = {
                1: '-1009x637y1064z',
                2: '-1016x738y990z',
                3: '-103x494y1518z',
                4: '-1050x1135y410z',
                5: '-1050x589y1052z',
                6: '-1062x689y977z',
                7: '-1089x538y1040z',
                8: '-1105x638y964z',
                9: '-1111x1081y394z',
                10: '-1125x484y1028z',
                11: '-113x1077y1177z',
                12: '-1145x583y951z',
                13: '-1159x428y1016z',
                14: '-115x0y1595z',
                15: '-1169x1024y379z',
                16: '-1183x526y939z',
                17: '-1189x370y1003z',
                18: '-1216x310y991z',
                19: '-1218x467y926z',
                20: '-1224x964y363z',
                21: '-1241x247y978z',
                22: '-1249x406y912z',
                23: '-1262x183y966z',
                24: '-1275x900y348z',
                25: '-1277x342y899z',
                26: '-1279x118y953z',
                27: '-1302x276y886z',
                28: '-1324x209y873z',
                29: '-1324x834y332z',
                30: '-133x503y1512z',
                31: '-1342x141y859z',
                32: '-1356x71y846z',
                33: '-1366x0y832z',
                34: '-1368x765y316z',
                35: '-1374x54y999z',
                36: '-1409x694y301z',
                37: '-1446x620y285z',
                38: '-1479x545y269z',
                39: '-1508x467y253z',
                40: '-1533x388y238z',
                41: '-1554x308y222z',
                42: '-1570x226y206z',
                43: '-1582x144y190z',
                44: '-1589x61y174z',
                45: '-163x510y1507z',
                46: '-170x994y1241z',
                47: '-171x1081y1166z',
                48: '-175x1475y592z',
                49: '-195x514y1502z',
                50: '-19x6y1599z',
                51: '-224x996y1231z',
                52: '-228x517y1496z',
                53: '-230x1082y1155z',
                54: '-253x1470y577z',
                55: '-262x518y1490z',
                56: '-279x995y1221z',
                57: '-289x1079y1144z',
                58: '-296x516y1484z',
                59: '-330x513y1478z',
                60: '-331x1460y562z',
                61: '-335x990y1210z',
                62: '-348x1074y1133z',
                63: '-34x9y1599z',
                64: '-365x507y1472z',
                65: '-391x983y1200z',
                66: '-3x1y1599z',
                67: '-401x498y1466z',
                68: '-408x1064y1122z',
                69: '-408x1446y547z',
                70: '-436x487y1459z',
                71: '-447x972y1189z',
                72: '-468x1052y1110z',
                73: '-471x474y1453z',
                74: '-485x1428y532z',
                75: '-48x472y1527z',
                76: '-503x957y1178z',
                77: '-506x459y1446z',
                78: '-50x11y1599z',
                79: '-527x1036y1099z',
                80: '-541x441y1439z',
                81: '-558x940y1167z',
                82: '-561x1405y517z',
                83: '-575x420y1432z',
                84: '-586x1016y1087z',
                85: '-608x397y1425z',
                86: '-613x919y1156z',
                87: '-636x1379y502z',
                88: '-640x372y1418z',
                89: '-645x993y1075z',
                90: '-667x895y1145z',
                91: '-671x344y1410z',
                92: '-67x10y1598z',
                93: '-701x315y1402z',
                94: '-702x966y1063z',
                95: '-710x1348y487z',
                96: '-720x867y1134z',
                97: '-730x282y1395z',
                98: '-757x248y1387z',
                99: '-758x937y1051z',
                100: '-75x484y1523z',
                101: '-772x837y1123z',
                102: '-782x1313y471z',
                103: '-782x212y1379z',
                104: '-806x174y1371z',
                105: '-813x903y1039z',
                106: '-823x803y1111z',
                107: '-827x133y1362z',
                108: '-83x9y1597z',
                109: '-846x91y1354z',
                110: '-852x1274y456z',
                111: '-864x48y1345z',
                112: '-867x867y1027z',
                113: '-872x766y1100z',
                114: '-878x2y1337z',
                115: '-919x827y1014z',
                116: '-920x1231y441z',
                117: '-920x726y1088z',
                118: '-965x683y1076z',
                119: '-969x784y1002z',
                120: '-986x1185y425z',
                121: '-99x5y1596z'}

shot2five17004xi = {
                1: '-1026x726y1144z',
                2: '-1029x833y1065z',
                3: '-1048x1259y452z',
                4: '-106x6y1696z',
                5: '-1072x677y1131z',
                6: '-1080x784y1051z',
                7: '-110x525y1612z',
                8: '-1115x1206y435z',
                9: '-1116x626y1118z',
                10: '-1128x733y1038z',
                11: '-1157x571y1105z',
                12: '-1174x678y1025z',
                13: '-1180x1149y419z',
                14: '-1196x514y1092z',
                15: '-120x1144y1251z',
                16: '-1217x620y1011z',
                17: '-1231x455y1079z',
                18: '-123x0y1695z',
                19: '-1242x1088y402z',
                20: '-1257x559y997z',
                21: '-1263x393y1066z',
                22: '-1293x329y1053z',
                23: '-1294x496y983z',
                24: '-1300x1024y386z',
                25: '-1318x263y1039z',
                26: '-1327x431y969z',
                27: '-1340x195y1026z',
                28: '-1355x957y369z',
                29: '-1357x363y955z',
                30: '-1359x125y1012z',
                31: '-1384x294y941z',
                32: '-1406x886y353z',
                33: '-1407x222y927z',
                34: '-141x534y1607z',
                35: '-1425x149y913z',
                36: '-1440x75y898z',
                37: '-1451x0y884z',
                38: '-1454x813y336z',
                39: '-1455x58y1057z',
                40: '-1497x737y319z',
                41: '-1537x659y303z',
                42: '-1572x579y286z',
                43: '-1603x497y269z',
                44: '-1629x413y252z',
                45: '-1651x327y236z',
                46: '-1668x241y219z',
                47: '-1680x153y202z',
                48: '-1688x65y185z',
                49: '-174x541y1601z',
                50: '-180x1056y1319z',
                51: '-181x1148y1239z',
                52: '-186x1568y629z',
                53: '-208x547y1596z',
                54: '-20x6y1699z',
                55: '-238x1058y1308z',
                56: '-242x550y1590z',
                57: '-244x1149y1227z',
                58: '-269x1562y613z',
                59: '-278x550y1584z',
                60: '-297x1057y1297z',
                61: '-307x1147y1216z',
                62: '-314x549y1577z',
                63: '-351x1552y597z',
                64: '-351x545y1571z',
                65: '-356x1052y1286z',
                66: '-36x10y1699z',
                67: '-370x1141y1204z',
                68: '-388x538y1564z',
                69: '-415x1044y1275z',
                70: '-426x529y1558z',
                71: '-434x1131y1192z',
                72: '-434x1537y581z',
                73: '-463x518y1551z',
                74: '-475x1032y1263z',
                75: '-497x1117y1180z',
                76: '-4x1y1699z',
                77: '-501x504y1544z',
                78: '-515x1517y565z',
                79: '-51x502y1623z',
                80: '-534x1017y1252z',
                81: '-538x487y1537z',
                82: '-54x11y1699z',
                83: '-560x1100y1167z',
                84: '-574x468y1529z',
                85: '-593x999y1240z',
                86: '-596x1493y549z',
                87: '-610x446y1522z',
                88: '-623x1080y1155z',
                89: '-646x422y1514z',
                90: '-651x976y1229z',
                91: '-676x1465y533z',
                92: '-680x395y1506z',
                93: '-685x1055y1142z',
                94: '-709x951y1217z',
                95: '-713x366y1498z',
                96: '-71x11y1698z',
                97: '-745x334y1490z',
                98: '-746x1027y1130z',
                99: '-754x1432y517z',
                100: '-765x922y1205z',
                101: '-775x300y1482z',
                102: '-79x514y1618z',
                103: '-804x264y1474z',
                104: '-806x995y1117z',
                105: '-821x889y1193z',
                106: '-831x1395y501z',
                107: '-831x225y1465z',
                108: '-856x184y1456z',
                109: '-864x960y1104z',
                110: '-875x853y1181z',
                111: '-879x142y1447z',
                112: '-88x9y1697z',
                113: '-899x97y1438z',
                114: '-905x1354y484z',
                115: '-918x51y1429z',
                116: '-921x921y1091z',
                117: '-927x814y1169z',
                118: '-933x2y1420z',
                119: '-976x879y1078z',
                120: '-977x772y1156z',
                121: '-978x1308y468z'}
       
shot2five18004xi = {
                1: '-1034x931y1141z',
                2: '-1035x1385y496z',
                3: '-1035x817y1224z',
                4: '-1086x769y1211z',
                5: '-1090x882y1127z',
                6: '-1110x1333y478z',
                7: '-112x6y1796z',
                8: '-1135x717y1198z',
                9: '-1143x831y1113z',
                10: '-116x556y1707z',
                11: '-1181x1277y461z',
                12: '-1182x663y1184z',
                13: '-1195x776y1099z',
                14: '-1225x605y1170z',
                15: '-1243x717y1085z',
                16: '-1250x1216y444z',
                17: '-1266x545y1157z',
                18: '-127x1211y1324z',
                19: '-1289x656y1070z',
                20: '-1303x482y1143z',
                21: '-130x0y1795z',
                22: '-1315x1152y426z',
                23: '-1331x592y1056z',
                24: '-1338x416y1129z',
                25: '-1369x348y1115z',
                26: '-1370x526y1041z',
                27: '-1377x1084y409z',
                28: '-1396x278y1101z',
                29: '-1405x456y1027z',
                30: '-1419x206y1086z',
                31: '-1435x1013y391z',
                32: '-1437x385y1012z',
                33: '-1439x133y1072z',
                34: '-1465x311y997z',
                35: '-1489x235y982z',
                36: '-1489x938y374z',
                37: '-149x566y1702z',
                38: '-1509x158y967z',
                39: '-1525x79y951z',
                40: '-1535x61y1116z',
                41: '-1537x0y936z',
                42: '-1539x861y356z',
                43: '-1585x781y338z',
                44: '-1627x698y321z',
                45: '-1664x613y303z',
                46: '-1697x526y285z',
                47: '-1725x437y267z',
                48: '-1748x346y249z',
                49: '-1766x255y232z',
                50: '-1779x162y214z',
                51: '-1787x69y196z',
                52: '-184x573y1696z',
                53: '-191x1119y1396z',
                54: '-192x1216y1312z',
                55: '-197x1660y666z',
                56: '-21x7y1799z',
                57: '-220x579y1689z',
                58: '-252x1121y1385z',
                59: '-257x582y1683z',
                60: '-258x1217y1300z',
                61: '-285x1654y649z',
                62: '-294x583y1677z',
                63: '-314x1119y1373z',
                64: '-325x1214y1287z',
                65: '-333x581y1670z',
                66: '-372x1643y632z',
                67: '-372x577y1663z',
                68: '-377x1114y1362z',
                69: '-392x1208y1275z',
                70: '-39x10y1799z',
                71: '-411x570y1656z',
                72: '-440x1105y1350z',
                73: '-451x560y1649z',
                74: '-459x1197y1262z',
                75: '-459x1627y616z',
                76: '-491x548y1642z',
                77: '-4x1y1799z',
                78: '-503x1093y1338z',
                79: '-527x1183y1249z',
                80: '-530x533y1635z',
                81: '-546x1607y599z',
                82: '-54x531y1718z',
                83: '-565x1077y1326z',
                84: '-569x516y1627z',
                85: '-57x12y1799z',
                86: '-593x1165y1236z',
                87: '-608x496y1619z',
                88: '-628x1057y1313z',
                89: '-631x1581y582z',
                90: '-646x473y1611z',
                91: '-660x1143y1223z',
                92: '-684x447y1603z',
                93: '-690x1034y1301z',
                94: '-716x1551y565z',
                95: '-720x419y1595z',
                96: '-725x1117y1209z',
                97: '-750x1007y1289z',
                98: '-755x388y1586z',
                99: '-75x12y1798z',
                100: '-789x354y1578z',
                101: '-790x1087y1196z',
                102: '-799x1517y547z',
                103: '-810x976y1276z',
                104: '-821x318y1569z',
                105: '-84x545y1713z',
                106: '-851x279y1560z',
                107: '-853x1054y1183z',
                108: '-869x941y1263z',
                109: '-880x1477y530z',
                110: '-880x238y1551z',
                111: '-906x195y1542z',
                112: '-915x1016y1169z',
                113: '-926x903y1250z',
                114: '-931x150y1533z',
                115: '-93x10y1797z',
                116: '-952x103y1523z',
                117: '-959x1434y513z',
                118: '-972x54y1513z',
                119: '-975x975y1155z',
                120: '-981x862y1237z',
                121: '-988x3y1504z'}

shot2five19004xi = {
                1: '-1005x108y1608z',
                2: '-1012x1513y542z',
                3: '-1026x57y1598z',
                4: '-1029x1029y1219z',
                5: '-1036x910y1306z',
                6: '-1043x3y1587z',
                7: '-1091x982y1205z',
                8: '-1092x862y1292z',
                9: '-1093x1462y523z',
                10: '-1147x811y1278z',
                11: '-1150x931y1190z',
                12: '-1171x1407y505z',
                13: '-118x6y1896z',
                14: '-1198x757y1264z',
                15: '-1207x877y1175z',
                16: '-122x587y1802z',
                17: '-1247x1347y487z',
                18: '-1247x699y1250z',
                19: '-1261x819y1160z',
                20: '-1293x639y1235z',
                21: '-1312x757y1145z',
                22: '-1319x1284y468z',
                23: '-1336x575y1221z',
                24: '-134x1279y1398z',
                25: '-1360x693y1130z',
                26: '-1376x508y1206z',
                27: '-137x0y1895z',
                28: '-1388x1216y450z',
                29: '-1405x625y1115z',
                30: '-1412x439y1192z',
                31: '-1445x368y1177z',
                32: '-1446x555y1099z',
                33: '-1453x1144y431z',
                34: '-1473x294y1162z',
                35: '-1484x482y1084z',
                36: '-1498x218y1147z',
                37: '-1514x1069y413z',
                38: '-1517x406y1068z',
                39: '-1519x140y1132z',
                40: '-1547x328y1052z',
                41: '-1572x249y1036z',
                42: '-1572x991y394z',
                43: '-158x597y1796z',
                44: '-1593x167y1020z',
                45: '-1610x84y1004z',
                46: '-1616x64y1175z',
                47: '-1622x0y988z',
                48: '-1625x909y376z',
                49: '-1673x824y357z',
                50: '-1718x737y338z',
                51: '-1757x647y320z',
                52: '-1791x555y301z',
                53: '-1821x461y282z',
                54: '-1845x366y263z',
                55: '-1864x269y245z',
                56: '-1878x171y226z',
                57: '-1887x73y207z',
                58: '-194x605y1790z',
                59: '-202x1181y1474z',
                60: '-203x1284y1385z',
                61: '-208x1752y703z',
                62: '-22x7y1899z',
                63: '-232x611y1783z',
                64: '-266x1183y1462z',
                65: '-271x614y1777z',
                66: '-273x1285y1372z',
                67: '-300x1746y685z',
                68: '-311x615y1770z',
                69: '-332x1181y1450z',
                70: '-343x1282y1359z',
                71: '-351x613y1763z',
                72: '-392x609y1756z',
                73: '-393x1734y668z',
                74: '-398x1176y1437z',
                75: '-414x1275y1345z',
                76: '-41x11y1899z',
                77: '-434x602y1748z',
                78: '-464x1167y1425z',
                79: '-476x592y1741z',
                80: '-485x1264y1332z',
                81: '-485x1718y650z',
                82: '-4x1y1899z',
                83: '-518x579y1733z',
                84: '-531x1154y1412z',
                85: '-556x1249y1318z',
                86: '-560x563y1725z',
                87: '-576x1696y632z',
                88: '-57x561y1814z',
                89: '-597x1137y1399z',
                90: '-601x545y1717z',
                91: '-60x13y1898z',
                92: '-626x1230y1305z',
                93: '-642x523y1709z',
                94: '-663x1116y1386z',
                95: '-666x1669y614z',
                96: '-682x499y1701z',
                97: '-696x1207y1291z',
                98: '-722x472y1692z',
                99: '-728x1091y1373z',
                100: '-755x1637y596z',
                101: '-760x442y1683z',
                102: '-766x1179y1277z',
                103: '-792x1063y1360z',
                104: '-797x409y1675z',
                105: '-79x13y1898z',
                106: '-833x374y1666z',
                107: '-834x1148y1263z',
                108: '-843x1601y578z',
                109: '-855x1030y1347z',
                110: '-867x336y1656z',
                111: '-899x295y1647z',
                112: '-89x575y1808z',
                113: '-901x1112y1248z',
                114: '-917x994y1333z',
                115: '-928x1559y560z',
                116: '-929x252y1637z',
                117: '-957x206y1628z',
                118: '-966x1073y1234z',
                119: '-978x954y1320z',
                120: '-982x158y1618z',
                121: '-99x10y1897z'}

shot2five20004xi = {
                1: '-1007x217y1713z',
                2: '-1017x1129y1299z',
                3: '-1029x1004y1389z',
                4: '-1034x167y1703z',
                5: '-104x11y1997z',
                6: '-1058x114y1692z',
                7: '-1065x1593y570z',
                8: '-1080x60y1682z',
                9: '-1084x1084y1284z',
                10: '-1091x958y1375z',
                11: '-1098x3y1671z',
                12: '-1148x1034y1268z',
                13: '-1150x1539y551z',
                14: '-1150x908y1360z',
                15: '-1207x854y1346z',
                16: '-1211x980y1253z',
                17: '-1233x1481y532z',
                18: '-124x7y1996z',
                19: '-1261x797y1331z',
                20: '-1271x923y1237z',
                21: '-129x618y1897z',
                22: '-1312x1418y512z',
                23: '-1313x736y1316z',
                24: '-1327x862y1221z',
                25: '-1361x672y1301z',
                26: '-1381x797y1205z',
                27: '-1388x1351y493z',
                28: '-1407x605y1285z',
                29: '-141x1346y1472z',
                30: '-1432x729y1189z',
                31: '-1448x535y1270z',
                32: '-144x0y1994z',
                33: '-1461x1280y474z',
                34: '-1479x658y1173z',
                35: '-1486x462y1254z',
                36: '-1521x387y1239z',
                37: '-1522x584y1157z',
                38: '-1530x1205y454z',
                39: '-1551x309y1223z',
                40: '-1562x507y1141z',
                41: '-1577x229y1207z',
                42: '-1594x1125y435z',
                43: '-1597x428y1124z',
                44: '-1599x148y1191z',
                45: '-1628x346y1108z',
                46: '-1655x1043y415z',
                47: '-1655x262y1091z',
                48: '-166x629y1891z',
                49: '-1677x176y1074z',
                50: '-1695x88y1057z',
                51: '-1697x67y1234z',
                52: '-1707x0y1040z',
                53: '-1710x957y395z',
                54: '-1762x867y376z',
                55: '-1808x776y356z',
                56: '-1849x681y337z',
                57: '-1886x584y317z',
                58: '-1917x485y297z',
                59: '-1942x385y277z',
                60: '-1962x283y257z',
                61: '-1977x180y238z',
                62: '-1986x77y218z',
                63: '-204x637y1884z',
                64: '-212x1243y1551z',
                65: '-214x1351y1458z',
                66: '-219x1844y740z',
                67: '-23x7y1999z',
                68: '-244x643y1877z',
                69: '-280x1245y1539z',
                70: '-285x647y1870z',
                71: '-287x1352y1444z',
                72: '-316x1838y721z',
                73: '-327x647y1863z',
                74: '-349x1244y1526z',
                75: '-361x1349y1430z',
                76: '-370x646y1856z',
                77: '-413x641y1848z',
                78: '-414x1825y703z',
                79: '-419x1238y1513z',
                80: '-436x1342y1416z',
                81: '-43x11y1999z',
                82: '-457x633y1840z',
                83: '-489x1228y1500z',
                84: '-4x1y1999z',
                85: '-501x623y1833z',
                86: '-510x1331y1402z',
                87: '-510x1808y684z',
                88: '-545x609y1824z',
                89: '-559x1215y1486z',
                90: '-585x1315y1388z',
                91: '-589x593y1816z',
                92: '-607x1785y665z',
                93: '-60x590y1909z',
                94: '-628x1197y1473z',
                95: '-633x573y1808z',
                96: '-63x13y1998z',
                97: '-659x1295y1373z',
                98: '-676x551y1799z',
                99: '-698x1175y1459z',
                100: '-702x1757y646z',
                101: '-718x525y1790z',
                102: '-733x1270y1359z',
                103: '-760x497y1781z',
                104: '-766x1149y1446z',
                105: '-795x1724y627z',
                106: '-800x465y1772z',
                107: '-806x1241y1344z',
                108: '-834x1119y1432z',
                109: '-839x431y1763z',
                110: '-83x13y1998z',
                111: '-877x393y1753z',
                112: '-878x1208y1329z',
                113: '-887x1685y608z',
                114: '-900x1084y1418z',
                115: '-912x353y1744z',
                116: '-93x605y1903z',
                117: '-946x310y1734z',
                118: '-948x1171y1314z',
                119: '-966x1046y1404z',
                120: '-977x1641y589z',
                121: '-978x265y1724z'}         


shot2five21004xi = {
                1: '-1014x1098y1474z',
                2: '-1026x1724y619z',
                3: '-1027x278y1810z',
                4: '-1057x228y1799z',
                5: '-1068x1186y1364z',
                6: '-1080x1054y1459z',
                7: '-1086x175y1788z',
                8: '-109x12y2097z',
                9: '-1111x120y1777z',
                10: '-1118x1673y599z',
                11: '-1134x63y1766z',
                12: '-1138x1138y1348z',
                13: '-1145x1006y1444z',
                14: '-1153x3y1754z',
                15: '-1206x1086y1332z',
                16: '-1207x953y1428z',
                17: '-1208x1616y578z',
                18: '-1267x897y1413z',
                19: '-1271x1029y1315z',
                20: '-1295x1555y558z',
                21: '-131x7y2095z',
                22: '-1324x837y1397z',
                23: '-1334x969y1299z',
                24: '-135x649y1992z',
                25: '-1378x1489y538z',
                26: '-1379x773y1381z',
                27: '-1394x905y1282z',
                28: '-1429x706y1366z',
                29: '-1450x837y1266z',
                30: '-1458x1419y518z',
                31: '-1477x636y1350z',
                32: '-148x1413y1545z',
                33: '-1503x766y1249z',
                34: '-1521x562y1333z',
                35: '-152x0y2094z',
                36: '-1534x1344y497z',
                37: '-1553x691y1232z',
                38: '-1561x486y1317z',
                39: '-1597x406y1301z',
                40: '-1598x613y1215z',
                41: '-1606x1265y477z',
                42: '-1629x325y1284z',
                43: '-1640x532y1198z',
                44: '-1656x241y1267z',
                45: '-1674x1182y456z',
                46: '-1677x449y1180z',
                47: '-1679x155y1251z',
                48: '-1710x363y1163z',
                49: '-1737x1095y436z',
                50: '-1738x275y1145z',
                51: '-174x660y1985z',
                52: '-1761x185y1128z',
                53: '-1778x71y1293z',
                54: '-1779x93y1110z',
                55: '-1793x0y1092z',
                56: '-1796x1004y415z',
                57: '-1850x911y395z',
                58: '-1898x814y374z',
                59: '-1942x715y353z',
                60: '-1980x613y333z',
                61: '-2012x510y312z',
                62: '-2039x404y291z',
                63: '-2061x297y270z',
                64: '-2076x189y249z',
                65: '-2085x81y229z',
                66: '-215x669y1978z',
                67: '-223x1305y1629z',
                68: '-224x1419y1531z',
                69: '-230x1937y777z',
                70: '-24x8y2099z',
                71: '-256x675y1971z',
                72: '-294x1307y1616z',
                73: '-299x679y1964z',
                74: '-301x1420y1516z',
                75: '-332x1929y758z',
                76: '-343x680y1956z',
                77: '-367x1306y1602z',
                78: '-379x1417y1502z',
                79: '-388x678y1949z',
                80: '-434x1917y738z',
                81: '-434x673y1941z',
                82: '-440x1300y1589z',
                83: '-458x1409y1487z',
                84: '-45x12y2099z',
                85: '-480x665y1933z',
                86: '-4x1y2099z',
                87: '-513x1290y1575z',
                88: '-526x654y1924z',
                89: '-536x1397y1472z',
                90: '-536x1898y718z',
                91: '-572x640y1916z',
                92: '-587x1275y1561z',
                93: '-614x1381y1457z',
                94: '-619x622y1907z',
                95: '-637x1874y698z',
                96: '-63x620y2005z',
                97: '-660x1257y1547z',
                98: '-664x602y1898z',
                99: '-66x14y2098z',
                100: '-692x1359y1442z',
                101: '-710x578y1889z',
                102: '-732x1234y1532z',
                103: '-737x1845y679z',
                104: '-754x552y1880z',
                105: '-770x1334y1427z',
                106: '-798x522y1870z',
                107: '-805x1206y1518z',
                108: '-835x1810y659z',
                109: '-840x488y1861z',
                110: '-846x1303y1411z',
                111: '-876x1175y1503z',
                112: '-881x452y1851z',
                113: '-88x14y2098z',
                114: '-920x413y1841z',
                115: '-922x1269y1396z',
                116: '-932x1769y639z',
                117: '-945x1139y1489z',
                118: '-958x371y1831z',
                119: '-98x635y1998z',
                120: '-993x326y1820z',
                121: '-996x1229y1380z'}

shot2five22004xi = {
                1: '-1004x389y1918z',
                2: '-103x666y2094z',
                3: '-1041x341y1907z',
                4: '-1043x1288y1446z',
                5: '-1062x1151y1544z',
                6: '-1075x1806y648z',
                7: '-1076x292y1896z',
                8: '-1108x239y1885z',
                9: '-1119x1242y1429z',
                10: '-1132x1104y1528z',
                11: '-1137x183y1873z',
                12: '-114x12y2196z',
                13: '-1164x126y1862z',
                14: '-1172x1752y627z',
                15: '-1188x66y1850z',
                16: '-1192x1192y1412z',
                17: '-1200x1054y1512z',
                18: '-1208x3y1838z',
                19: '-1263x1137y1395z',
                20: '-1265x999y1496z',
                21: '-1266x1693y606z',
                22: '-1328x940y1480z',
                23: '-1332x1078y1378z',
                24: '-1356x1629y585z',
                25: '-137x7y2195z',
                26: '-1387x877y1464z',
                27: '-1398x1015y1361z',
                28: '-142x680y2087z',
                29: '-1444x1560y564z',
                30: '-1444x810y1447z',
                31: '-1460x948y1343z',
                32: '-1498x740y1431z',
                33: '-1519x877y1326z',
                34: '-1527x1486y542z',
                35: '-1547x666y1414z',
                36: '-155x1481y1619z',
                37: '-1575x802y1308z',
                38: '-1593x589y1397z',
                39: '-159x0y2194z',
                40: '-1607x1408y521z',
                41: '-1627x724y1291z',
                42: '-1635x509y1380z',
                43: '-1673x426y1363z',
                44: '-1674x642y1273z',
                45: '-1683x1325y500z',
                46: '-1706x340y1345z',
                47: '-1718x558y1255z',
                48: '-1735x252y1328z',
                49: '-1754x1238y478z',
                50: '-1757x470y1237z',
                51: '-1759x162y1310z',
                52: '-1791x380y1218z',
                53: '-1820x1147y457z',
                54: '-1820x288y1200z',
                55: '-183x692y2080z',
                56: '-1845x193y1181z',
                57: '-1859x74y1351z',
                58: '-1864x97y1163z',
                59: '-1878x0y1144z',
                60: '-1881x1052y435z',
                61: '-1938x954y414z',
                62: '-1989x853y392z',
                63: '-2034x749y370z',
                64: '-2074x643y349z',
                65: '-2108x534y327z',
                66: '-2137x424y305z',
                67: '-2159x312y283z',
                68: '-2175x198y261z',
                69: '-2185x84y240z',
                70: '-225x701y2072z',
                71: '-234x1367y1707z',
                72: '-235x1486y1604z',
                73: '-241x2029y814z',
                74: '-269x707y2065z',
                75: '-26x8y2199z',
                76: '-309x1370y1693z',
                77: '-314x711y2057z',
                78: '-316x1488y1589z',
                79: '-348x2021y794z',
                80: '-360x712y2049z',
                81: '-384x1368y1679z',
                82: '-397x1484y1573z',
                83: '-407x710y2041z',
                84: '-454x705y2033z',
                85: '-455x2008y773z',
                86: '-461x1362y1664z',
                87: '-479x1476y1558z',
                88: '-47x13y2199z',
                89: '-503x697y2025z',
                90: '-538x1351y1650z',
                91: '-551x685y2016z',
                92: '-562x1464y1542z',
                93: '-562x1989y752z',
                94: '-5x2y2199z',
                95: '-600x670y2007z',
                96: '-614x1336y1635z',
                97: '-644x1446y1527z',
                98: '-648x652y1998z',
                99: '-667x1964y732z',
                100: '-66x649y2100z',
                101: '-691x1316y1620z',
                102: '-696x631y1989z',
                103: '-69x15y2198z',
                104: '-725x1424y1511z',
                105: '-744x606y1979z',
                106: '-767x1292y1605z',
                107: '-772x1933y711z',
                108: '-790x578y1969z',
                109: '-806x1397y1495z',
                110: '-836x546y1959z',
                111: '-843x1264y1590z',
                112: '-875x1896y690z',
                113: '-880x512y1949z',
                114: '-887x1366y1478z',
                115: '-917x1230y1575z',
                116: '-923x474y1939z',
                117: '-92x15y2198z',
                118: '-964x433y1929z',
                119: '-966x1329y1462z',
                120: '-976x1854y669z',
                121: '-991x1193y1560z'}

shot2five23004xi = {
                1: '-1008x452y2016z',
                2: '-1009x1390y1528z',
                3: '-1020x1938y700z',
                4: '-1036x1247y1630z',
                5: '-1049x406y2005z',
                6: '-1088x357y1994z',
                7: '-108x696y2189z',
                8: '-1090x1347y1511z',
                9: '-1110x1203y1614z',
                10: '-1124x1888y678z',
                11: '-1124x305y1982z',
                12: '-1158x250y1970z',
                13: '-1169x1299y1494z',
                14: '-1183x1154y1598z',
                15: '-1189x192y1959z',
                16: '-120x13y2296z',
                17: '-1217x131y1946z',
                18: '-1225x1832y656z',
                19: '-1242x69y1934z',
                20: '-1246x1246y1476z',
                21: '-1254x1101y1581z',
                22: '-1263x4y1921z',
                23: '-1321x1189y1459z',
                24: '-1322x1044y1564z',
                25: '-1323x1770y634z',
                26: '-1388x982y1547z',
                27: '-1393x1128y1441z',
                28: '-1418x1703y611z',
                29: '-143x8y2295z',
                30: '-1451x917y1530z',
                31: '-1461x1062y1423z',
                32: '-148x711y2182z',
                33: '-1509x1631y589z',
                34: '-1510x847y1513z',
                35: '-1527x991y1405z',
                36: '-1566x773y1496z',
                37: '-1589x917y1386z',
                38: '-1597x1554y567z',
                39: '-1618x696y1478z',
                40: '-162x1548y1692z',
                41: '-1647x839y1368z',
                42: '-1666x616y1460z',
                43: '-166x0y2293z',
                44: '-1680x1472y545z',
                45: '-1701x757y1349z',
                46: '-1709x532y1443z',
                47: '-1749x445y1425z',
                48: '-1751x672y1331z',
                49: '-1759x1385y522z',
                50: '-1784x356y1407z',
                51: '-1796x583y1312z',
                52: '-1814x264y1388z',
                53: '-1833x1294y500z',
                54: '-1837x492y1293z',
                55: '-1839x170y1370z',
                56: '-1872x398y1274z',
                57: '-1903x1199y477z',
                58: '-1903x301y1255z',
                59: '-191x723y2174z',
                60: '-1929x202y1235z',
                61: '-1940x77y1410z',
                62: '-1949x102y1216z',
                63: '-1964x0y1196z',
                64: '-1967x1100y455z',
                65: '-2026x998y432z',
                66: '-2079x892y410z',
                67: '-2127x783y387z',
                68: '-2169x672y364z',
                69: '-2204x558y342z',
                70: '-2234x443y319z',
                71: '-2257x326y296z',
                72: '-2274x207y273z',
                73: '-2284x88y250z',
                74: '-235x733y2167z',
                75: '-244x1429y1784z',
                76: '-246x1554y1677z',
                77: '-252x2121y851z',
                78: '-27x9y2299z',
                79: '-281x740y2159z',
                80: '-323x1432y1770z',
                81: '-328x744y2151z',
                82: '-330x1555y1661z',
                83: '-364x2113y830z',
                84: '-376x745y2143z',
                85: '-402x1430y1755z',
                86: '-415x1552y1645z',
                87: '-425x742y2134z',
                88: '-475x737y2125z',
                89: '-476x2099y808z',
                90: '-482x1424y1740z',
                91: '-49x13y2299z',
                92: '-501x1543y1629z',
                93: '-525x728y2117z',
                94: '-562x1413y1725z',
                95: '-576x716y2108z',
                96: '-587x1530y1612z',
                97: '-587x2079y787z',
                98: '-5x2y2299z',
                99: '-627x701y2098z',
                100: '-642x1397y1710z',
                101: '-673x1512y1596z',
                102: '-678x682y2089z',
                103: '-698x2053y765z',
                104: '-69x679y2196z',
                105: '-723x1376y1694z',
                106: '-728x659y2079z',
                107: '-73x15y2298z',
                108: '-758x1489y1579z',
                109: '-777x633y2069z',
                110: '-802x1351y1678z',
                111: '-807x2021y743z',
                112: '-826x604y2059z',
                113: '-843x1461y1563z',
                114: '-874x571y2049z',
                115: '-881x1321y1663z',
                116: '-915x1982y722z',
                117: '-920x535y2038z',
                118: '-927x1428y1546z',
                119: '-959x1286y1647z',
                120: '-965x495y2027z',
                121: '-96x15y2297z'}

shot2five24004xi = {
                1: '-1001x1342y1718z',
                2: '-1007x517y2115z',
                3: '-100x16y2397z',
                4: '-1052x472y2104z',
                5: '-1053x1450y1595z',
                6: '-1065x2022y730z',
                7: '-1081x1301y1701z',
                8: '-1095x424y2092z',
                9: '-112x726y2284z',
                10: '-1135x373y2080z',
                11: '-1138x1405y1577z',
                12: '-1159x1255y1684z',
                13: '-1173x1970y707z',
                14: '-1173x318y2068z',
                15: '-1209x261y2056z',
                16: '-1220x1355y1559z',
                17: '-1235x1205y1667z',
                18: '-1241x200y2044z',
                19: '-125x13y2396z',
                20: '-1270x137y2031z',
                21: '-1278x1912y684z',
                22: '-1296x72y2018z',
                23: '-1301x1301y1540z',
                24: '-1309x1149y1650z',
                25: '-1318x4y2005z',
                26: '-1378x1241y1522z',
                27: '-1380x1089y1632z',
                28: '-1381x1847y661z',
                29: '-1448x1025y1615z',
                30: '-1453x1177y1503z',
                31: '-1480x1778y638z',
                32: '-149x8y2395z',
                33: '-1514x956y1597z',
                34: '-1525x1108y1485z',
                35: '-155x742y2277z',
                36: '-1575x1702y615z',
                37: '-1576x884y1579z',
                38: '-1593x1034y1466z',
                39: '-1634x807y1561z',
                40: '-1658x957y1447z',
                41: '-1666x1622y592z',
                42: '-1688x726y1542z',
                43: '-169x1615y1766z',
                44: '-1718x875y1427z',
                45: '-1738x642y1524z',
                46: '-173x0y2393z',
                47: '-1753x1536y568z',
                48: '-1775x790y1408z',
                49: '-1784x555y1505z',
                50: '-1825x465y1487z',
                51: '-1827x701y1389z',
                52: '-1836x1446y545z',
                53: '-1861x371y1468z',
                54: '-1874x609y1369z',
                55: '-1893x275y1449z',
                56: '-1913x1351y522z',
                57: '-1916x513y1349z',
                58: '-1919x177y1429z',
                59: '-1954x415y1329z',
                60: '-1986x1251y498z',
                61: '-1986x314y1309z',
                62: '-199x755y2269z',
                63: '-2013x211y1289z',
                64: '-2021x80y1469z',
                65: '-2034x106y1269z',
                66: '-2049x0y1248z',
                67: '-2053x1148y475z',
                68: '-2114x1041y451z',
                69: '-2170x931y428z',
                70: '-2219x817y404z',
                71: '-2263x701y380z',
                72: '-2300x583y357z',
                73: '-2331x462y333z',
                74: '-2355x340y309z',
                75: '-2373x216y285z',
                76: '-2383x92y261z',
                77: '-245x765y2261z',
                78: '-255x1492y1862z',
                79: '-256x1622y1750z',
                80: '-263x2213y888z',
                81: '-28x9y2399z',
                82: '-293x772y2253z',
                83: '-337x1494y1847z',
                84: '-342x776y2244z',
                85: '-345x1623y1733z',
                86: '-380x2205y866z',
                87: '-393x777y2236z',
                88: '-419x1492y1831z',
                89: '-434x1619y1716z',
                90: '-444x775y2227z',
                91: '-496x2191y843z',
                92: '-496x769y2218z',
                93: '-503x1486y1816z',
                94: '-523x1611y1700z',
                95: '-52x14y2399z',
                96: '-548x760y2209z',
                97: '-587x1474y1800z',
                98: '-5x2y2399z',
                99: '-601x747y2199z',
                100: '-613x1597y1683z',
                101: '-613x2170y821z',
                102: '-654x731y2189z',
                103: '-670x1458y1784z',
                104: '-702x1578y1665z',
                105: '-707x711y2180z',
                106: '-728x2142y798z',
                107: '-72x708y2291z',
                108: '-754x1436y1768z',
                109: '-759x688y2169z',
                110: '-76x16y2398z',
                111: '-791x1554y1648z',
                112: '-811x661y2159z',
                113: '-837x1410y1751z',
                114: '-842x2108y776z',
                115: '-862x630y2148z',
                116: '-880x1524y1631z',
                117: '-912x596y2138z',
                118: '-920x1379y1735z',
                119: '-954x2068y753z',
                120: '-960x558y2127z',
                121: '-967x1490y1613z'}
       

shot2five25004xi = {
                1: '-1000x582y2215z',
                2: '-1008x1552y1680z',
                3: '-1042x1398y1790z',
                4: '-1049x538y2204z',
                5: '-104x17y2497z',
                6: '-1096x492y2192z',
                7: '-1097x1510y1661z',
                8: '-1109x2106y761z',
                9: '-1126x1356y1772z',
                10: '-1141x442y2180z',
                11: '-117x757y2379z',
                12: '-1183x388y2167z',
                13: '-1185x1464y1643z',
                14: '-1207x1308y1755z',
                15: '-1222x2052y737z',
                16: '-1222x331y2155z',
                17: '-1259x271y2142z',
                18: '-1271x1412y1624z',
                19: '-1286x1255y1737z',
                20: '-1293x209y2129z',
                21: '-130x14y2496z',
                22: '-1323x143y2116z',
                23: '-1332x1991y713z',
                24: '-1350x75y2102z',
                25: '-1355x1355y1605z',
                26: '-1363x1197y1719z',
                27: '-1373x4y2089z',
                28: '-1436x1293y1585z',
                29: '-1438x1135y1700z',
                30: '-1438x1924y689z',
                31: '-1509x1068y1682z',
                32: '-1514x1226y1566z',
                33: '-1541x1852y665z',
                34: '-155x8y2495z',
                35: '-1577x996y1663z',
                36: '-1588x1154y1546z',
                37: '-161x773y2371z',
                38: '-1641x1773y641z',
                39: '-1641x920y1645z',
                40: '-1659x1077y1527z',
                41: '-1702x841y1626z',
                42: '-1727x997y1507z',
                43: '-1736x1689y616z',
                44: '-1758x757y1607z',
                45: '-176x1683y1840z',
                46: '-1790x912y1487z',
                47: '-1811x669y1587z',
                48: '-181x0y2493z',
                49: '-1826x1600y592z',
                50: '-1849x823y1467z',
                51: '-1858x578y1568z',
                52: '-1901x484y1549z',
                53: '-1903x730y1446z',
                54: '-1912x1506y568z',
                55: '-1939x387y1529z',
                56: '-1952x634y1426z',
                57: '-1972x287y1509z',
                58: '-1993x1407y543z',
                59: '-1996x535y1405z',
                60: '-1999x185y1489z',
                61: '-2035x432y1385z',
                62: '-2068x1303y519z',
                63: '-2069x327y1364z',
                64: '-208x786y2363z',
                65: '-2096x220y1343z',
                66: '-2101x84y1528z',
                67: '-2118x111y1322z',
                68: '-2134x0y1300z',
                69: '-2138x1196y494z',
                70: '-2202x1084y470z',
                71: '-2260x970y445z',
                72: '-2312x851y421z',
                73: '-2357x730y396z',
                74: '-2396x607y371z',
                75: '-2428x481y347z',
                76: '-2453x354y322z',
                77: '-2471x225y297z',
                78: '-2483x96y272z',
                79: '-256x797y2355z',
                80: '-265x1554y1939z',
                81: '-267x1689y1823z',
                82: '-274x2306y925z',
                83: '-29x9y2499z',
                84: '-305x804y2347z',
                85: '-351x1557y1924z',
                86: '-357x808y2338z',
                87: '-359x1691y1805z',
                88: '-395x2297y902z',
                89: '-409x809y2329z',
                90: '-437x1555y1908z',
                91: '-452x1687y1788z',
                92: '-462x807y2320z',
                93: '-516x801y2310z',
                94: '-517x2282y879z',
                95: '-524x1548y1891z',
                96: '-545x1678y1770z',
                97: '-54x14y2499z',
                98: '-571x792y2301z',
                99: '-5x2y2499z',
                100: '-611x1535y1875z',
                101: '-626x779y2291z',
                102: '-638x1663y1753z',
                103: '-638x2260y855z',
                104: '-681x762y2281z',
                105: '-698x1518y1858z',
                106: '-731x1644y1735z',
                107: '-736x741y2270z',
                108: '-758x2232y832z',
                109: '-75x738y2387z',
                110: '-785x1496y1841z',
                111: '-791x717y2260z',
                112: '-79x17y2498z',
                113: '-824x1618y1717z',
                114: '-845x689y2249z',
                115: '-872x1469y1824z',
                116: '-877x2196y808z',
                117: '-898x657y2238z',
                118: '-916x1588y1698z',
                119: '-950x621y2227z',
                120: '-958x1436y1807z',
                121: '-994x2155y784z'}


shot2five26004xi = {
                1: '-1034x2241y816z',
                2: '-1040x605y2304z',
                3: '-1048x1614y1747z',
                4: '-1084x1454y1861z',
                5: '-1091x560y2292z',
                6: '-109x17y2597z',
                7: '-1140x512y2279z',
                8: '-1141x1571y1728z',
                9: '-1154x2191y791z',
                10: '-1171x1410y1843z',
                11: '-1186x459y2267z',
                12: '-122x787y2474z',
                13: '-1230x404y2254z',
                14: '-1233x1522y1708z',
                15: '-1255x1360y1825z',
                16: '-1271x2134y766z',
                17: '-1271x345y2241z',
                18: '-1309x282y2228z',
                19: '-1322x1468y1689z',
                20: '-1338x1305y1806z',
                21: '-1344x217y2214z',
                22: '-135x14y2596z',
                23: '-1376x149y2200z',
                24: '-1385x2071y741z',
                25: '-1404x78y2186z',
                26: '-1409x1409y1669z',
                27: '-1418x1245y1787z',
                28: '-1428x4y2172z',
                29: '-1493x1344y1649z',
                30: '-1495x1180y1768z',
                31: '-1496x2001y716z',
                32: '-1569x1111y1749z',
                33: '-1574x1275y1629z',
                34: '-1603x1926y691z',
                35: '-162x9y2594z',
                36: '-1640x1036y1730z',
                37: '-1652x1200y1608z',
                38: '-168x804y2466z',
                39: '-1706x1844y666z',
                40: '-1707x957y1711z',
                41: '-1726x1121y1588z',
                42: '-1770x874y1691z',
                43: '-1796x1037y1567z',
                44: '-1805x1757y641z',
                45: '-1829x787y1671z',
                46: '-183x1750y1913z',
                47: '-1862x948y1546z',
                48: '-1883x696y1651z',
                49: '-188x0y2593z',
                50: '-1899x1664y616z',
                51: '-1923x856y1525z',
                52: '-1933x601y1631z',
                53: '-1977x503y1611z',
                54: '-1979x759y1504z',
                55: '-1989x1566y591z',
                56: '-2016x402y1590z',
                57: '-2030x659y1483z',
                58: '-2050x298y1569z',
                59: '-2073x1463y565z',
                60: '-2076x556y1462z',
                61: '-2079x192y1549z',
                62: '-2117x450y1440z',
                63: '-2151x1356y540z',
                64: '-2151x340y1418z',
                65: '-216x818y2458z',
                66: '-2180x229y1396z',
                67: '-2182x87y1586z',
                68: '-2203x115y1374z',
                69: '-2220x0y1352z',
                70: '-2224x1244y514z',
                71: '-2290x1128y489z',
                72: '-2351x1008y463z',
                73: '-2404x885y438z',
                74: '-2451x760y412z',
                75: '-2492x631y386z',
                76: '-2525x501y361z',
                77: '-2551x368y335z',
                78: '-2570x235y309z',
                79: '-2582x100y283z',
                80: '-266x828y2449z',
                81: '-276x1616y2017z',
                82: '-278x1757y1896z',
                83: '-284x2398y962z',
                84: '-30x10y2599z',
                85: '-318x836y2441z',
                86: '-365x1619y2001z',
                87: '-371x841y2431z',
                88: '-373x1758y1878z',
                89: '-411x2389y938z',
                90: '-425x842y2422z',
                91: '-454x1617y1984z',
                92: '-470x1754y1860z',
                93: '-481x839y2413z',
                94: '-537x833y2403z',
                95: '-538x2373y914z',
                96: '-545x1609y1967z',
                97: '-567x1745y1841z',
                98: '-56x15y2599z',
                99: '-594x823y2393z',
                100: '-635x1597y1950z',
                101: '-651x810y2382z',
                102: '-664x1730y1823z',
                103: '-664x2350y889z',
                104: '-6x2y2599z',
                105: '-709x792y2372z',
                106: '-726x1579y1933z',
                107: '-761x1709y1804z',
                108: '-766x771y2361z',
                109: '-789x2321y865z',
                110: '-78x768y2482z',
                111: '-817x1556y1915z',
                112: '-823x745y2350z',
                113: '-82x17y2598z',
                114: '-857x1683y1785z',
                115: '-879x716y2339z',
                116: '-907x1527y1897z',
                117: '-912x2284y840z',
                118: '-934x683y2328z',
                119: '-953x1651y1766z',
                120: '-988x646y2316z',
                121: '-996x1494y1880z'}

shot2five27004xi = {
                1: '-1026x671y2405z',
                2: '-1035x1551y1952z',
                3: '-1074x2327y847z',
                4: '-1080x628y2393z',
                5: '-1088x1676y1814z',
                6: '-1126x1510y1933z',
                7: '-1133x582y2380z',
                8: '-113x18y2697z',
                9: '-1184x531y2367z',
                10: '-1185x1631y1794z',
                11: '-1198x2275y821z',
                12: '-1216x1464y1914z',
                13: '-1232x477y2354z',
                14: '-126x817y2570z',
                15: '-1277x419y2341z',
                16: '-1280x1581y1774z',
                17: '-1304x1412y1895z',
                18: '-1320x2216y796z',
                19: '-1320x358y2327z',
                20: '-1360x293y2313z',
                21: '-1373x1525y1754z',
                22: '-1389x1355y1876z',
                23: '-1396x225y2299z',
                24: '-140x15y2696z',
                25: '-1429x154y2285z',
                26: '-1438x2151y770z',
                27: '-1458x81y2270z',
                28: '-1463x1463y1733z',
                29: '-1472x1293y1856z',
                30: '-1483x4y2256z',
                31: '-1551x1396y1712z',
                32: '-1553x1226y1836z',
                33: '-1553x2078y744z',
                34: '-1630x1153y1817z',
                35: '-1635x1324y1691z',
                36: '-1665x2000y718z',
                37: '-168x9y2694z',
                38: '-1703x1076y1797z',
                39: '-1715x1246y1670z',
                40: '-174x835y2561z',
                41: '-1772x1915y692z',
                42: '-1773x994y1776z',
                43: '-1792x1164y1649z',
                44: '-1838x908y1756z',
                45: '-1865x1076y1627z',
                46: '-1875x1824y666z',
                47: '-1899x817y1735z',
                48: '-191x1817y1987z',
                49: '-1933x985y1606z',
                50: '-1955x723y1715z',
                51: '-195x0y2692z',
                52: '-1972x1728y639z',
                53: '-1997x889y1584z',
                54: '-2007x624y1694z',
                55: '-2053x523y1672z',
                56: '-2055x789y1562z',
                57: '-2065x1626y613z',
                58: '-2094x418y1651z',
                59: '-2108x685y1540z',
                60: '-2129x310y1630z',
                61: '-2152x1519y587z',
                62: '-2156x577y1518z',
                63: '-2159x199y1608z',
                64: '-2198x467y1495z',
                65: '-2234x1408y561z',
                66: '-2234x353y1473z',
                67: '-224x849y2553z',
                68: '-2263x90y1645z',
                69: '-2264x238y1450z',
                70: '-2288x119y1427z',
                71: '-2305x0y1404z',
                72: '-2309x1292y534z',
                73: '-2378x1171y508z',
                74: '-2441x1047y481z',
                75: '-2497x920y454z',
                76: '-2546x789y428z',
                77: '-2588x656y401z',
                78: '-2622x520y374z',
                79: '-2649x382y348z',
                80: '-2669x244y321z',
                81: '-2681x104y294z',
                82: '-276x860y2544z',
                83: '-287x1678y2095z',
                84: '-289x1824y1968z',
                85: '-295x2490y999z',
                86: '-32x10y2699z',
                87: '-330x868y2534z',
                88: '-379x1681y2078z',
                89: '-385x873y2525z',
                90: '-388x1826y1950z',
                91: '-427x2481y974z',
                92: '-442x874y2515z',
                93: '-472x1679y2060z',
                94: '-488x1822y1931z',
                95: '-499x872y2505z',
                96: '-558x2464y949z',
                97: '-558x865y2495z',
                98: '-566x1671y2043z',
                99: '-588x1812y1912z',
                100: '-58x16y2699z',
                101: '-617x855y2485z',
                102: '-660x1658y2025z',
                103: '-676x841y2474z',
                104: '-689x1796y1893z',
                105: '-689x2441y924z',
                106: '-6x2y2699z',
                107: '-736x823y2463z',
                108: '-754x1640y2007z',
                109: '-790x1775y1874z',
                110: '-795x800y2452z',
                111: '-819x2410y898z',
                112: '-81x797y2578z',
                113: '-848x1616y1989z',
                114: '-854x774y2441z',
                115: '-85x18y2698z',
                116: '-890x1748y1854z',
                117: '-913x744y2429z',
                118: '-942x1586y1970z',
                119: '-947x2372y873z',
                120: '-970x709y2417z',
                121: '-990x1715y1834z'}

shot2five28004xi = {
                1: '-1006x736y2507z',
                2: '-1027x1778y1902z',
                3: '-1064x696y2494z',
                4: '-1073x1608y2024z',
                5: '-1114x2413y878z',
                6: '-1120x651y2481z',
                7: '-1129x1738y1882z',
                8: '-1168x1566y2005z',
                9: '-1175x603y2468z',
                10: '-117x19y2797z',
                11: '-1227x551y2455z',
                12: '-1229x1692y1861z',
                13: '-1242x2359y852z',
                14: '-1261x1518y1985z',
                15: '-1277x495y2441z',
                16: '-131x847y2665z',
                17: '-1325x435y2427z',
                18: '-1328x1639y1840z',
                19: '-1352x1465y1965z',
                20: '-1369x2298y825z',
                21: '-1369x371y2413z',
                22: '-1410x304y2399z',
                23: '-1424x1581y1819z',
                24: '-1441x1406y1945z',
                25: '-1448x234y2384z',
                26: '-146x16y2796z',
                27: '-1482x160y2370z',
                28: '-1491x2230y798z',
                29: '-1512x84y2355z',
                30: '-1517x1517y1797z',
                31: '-1527x1341y1925z',
                32: '-1537x4y2339z',
                33: '-1608x1448y1776z',
                34: '-1610x1271y1905z',
                35: '-1611x2155y771z',
                36: '-1690x1196y1884z',
                37: '-1695x1373y1754z',
                38: '-1726x2074y744z',
                39: '-174x10y2794z',
                40: '-1766x1116y1863z',
                41: '-1779x1292y1732z',
                42: '-181x865y2656z',
                43: '-1838x1031y1842z',
                44: '-1838x1986y717z',
                45: '-1859x1207y1710z',
                46: '-1906x941y1821z',
                47: '-1934x1116y1688z',
                48: '-1944x1892y690z',
                49: '-1969x848y1800z',
                50: '-198x1885y2060z',
                51: '-2005x1021y1665z',
                52: '-2028x749y1778z',
                53: '-202x0y2792z',
                54: '-2045x1792y663z',
                55: '-2071x922y1643z',
                56: '-2081x648y1756z',
                57: '-2129x542y1734z',
                58: '-2131x818y1620z',
                59: '-2142x1687y636z',
                60: '-2172x433y1712z',
                61: '-2186x710y1597z',
                62: '-2208x321y1690z',
                63: '-2232x1576y609z',
                64: '-2236x599y1574z',
                65: '-2239x207y1668z',
                66: '-2280x484y1551z',
                67: '-2317x1460y581z',
                68: '-2317x367y1527z',
                69: '-233x880y2647z',
                70: '-2344x93y1704z',
                71: '-2348x246y1504z',
                72: '-2373x124y1480z',
                73: '-2391x0y1456z',
                74: '-2395x1339y554z',
                75: '-2466x1215y526z',
                76: '-2531x1086y499z',
                77: '-2589x954y471z',
                78: '-2640x818y444z',
                79: '-2683x680y416z',
                80: '-2719x539y388z',
                81: '-2748x397y361z',
                82: '-2768x253y333z',
                83: '-2781x108y305z',
                84: '-286x892y2638z',
                85: '-297x1740y2172z',
                86: '-299x1892y2041z',
                87: '-306x2582y1036z',
                88: '-33x11y2799z',
                89: '-342x901y2628z',
                90: '-393x1743y2154z',
                91: '-399x905y2619z',
                92: '-402x1893y2022z',
                93: '-443x2573y1010z',
                94: '-458x907y2609z',
                95: '-489x1741y2136z',
                96: '-506x1889y2003z',
                97: '-518x904y2598z',
                98: '-579x2556y984z',
                99: '-579x897y2588z',
                100: '-587x1733y2118z',
                101: '-60x16y2799z',
                102: '-610x1879y1983z',
                103: '-640x887y2577z',
                104: '-684x1720y2100z',
                105: '-6x2y2799z',
                106: '-702x872y2566z',
                107: '-715x1863y1963z',
                108: '-715x2531y958z',
                109: '-763x853y2554z',
                110: '-782x1701y2081z',
                111: '-819x1841y1943z',
                112: '-825x830y2543z',
                113: '-849x2499y931z',
                114: '-84x827y2673z',
                115: '-880x1676y2062z',
                116: '-886x803y2531z',
                117: '-88x19y2798z',
                118: '-923x1813y1923z',
                119: '-946x771y2519z',
                120: '-977x1645y2043z',
                121: '-982x2460y905z'}

shot2five29004xi = {
                1: '-1012x1704y2116z',
                2: '-1018x2548y937z',
                3: '-1042x762y2596z',
                4: '-1063x1842y1970z',
                5: '-1102x720y2583z',
                6: '-1111x1666y2096z',
                7: '-1153x2499y910z',
                8: '-1160x675y2570z',
                9: '-1169x1800y1949z',
                10: '-1209x1622y2076z',
                11: '-1217x625y2556z',
                12: '-121x19y2897z',
                13: '-1271x571y2542z',
                14: '-1273x1752y1927z',
                15: '-1287x2444y882z',
                16: '-1306x1573y2056z',
                17: '-1323x512y2528z',
                18: '-136x878y2760z',
                19: '-1372x450y2514z',
                20: '-1375x1698y1906z',
                21: '-1400x1517y2035z',
                22: '-1417x2380y855z',
                23: '-1418x384y2499z',
                24: '-1461x315y2485z',
                25: '-1475x1638y1884z',
                26: '-1492x1456y2015z',
                27: '-1499x242y2470z',
                28: '-151x16y2895z',
                29: '-1535x166y2454z',
                30: '-1545x2310y827z',
                31: '-1566x87y2439z',
                32: '-1572x1572y1862z',
                33: '-1581x1389y1994z',
                34: '-1592x5y2423z',
                35: '-1665x1500y1839z',
                36: '-1668x1316y1973z',
                37: '-1668x2232y799z',
                38: '-1750x1239y1951z',
                39: '-1756x1422y1817z',
                40: '-1788x2148y771z',
                41: '-180x10y2894z',
                42: '-1829x1156y1930z',
                43: '-1843x1339y1794z',
                44: '-187x896y2751z',
                45: '-1903x2057y743z',
                46: '-1904x1068y1908z',
                47: '-1925x1250y1771z',
                48: '-1974x975y1886z',
                49: '-2003x1156y1748z',
                50: '-2013x1960y715z',
                51: '-2040x878y1864z',
                52: '-205x1952y2134z',
                53: '-2076x1058y1725z',
                54: '-2100x776y1842z',
                55: '-210x1y2892z',
                56: '-2119x1856y687z',
                57: '-2145x955y1701z',
                58: '-2156x671y1819z',
                59: '-2205x561y1796z',
                60: '-2207x847y1678z',
                61: '-2218x1747y659z',
                62: '-2249x449y1774z',
                63: '-2265x735y1654z',
                64: '-2287x333y1751z',
                65: '-2312x1632y630z',
                66: '-2316x620y1630z',
                67: '-2319x214y1727z',
                68: '-2361x501y1606z',
                69: '-2399x1512y602z',
                70: '-2400x380y1582z',
                71: '-241x912y2742z',
                72: '-2425x97y1763z',
                73: '-2432x255y1558z',
                74: '-2457x128y1533z',
                75: '-2476x0y1508z',
                76: '-2480x1387y574z',
                77: '-2555x1258y545z',
                78: '-2622x1125y517z',
                79: '-2682x988y488z',
                80: '-2734x847y460z',
                81: '-2779x704y431z',
                82: '-2816x558y402z',
                83: '-2846x411y373z',
                84: '-2867x262y345z',
                85: '-2880x111y316z',
                86: '-297x924y2732z',
                87: '-308x1803y2250z',
                88: '-310x1959y2114z',
                89: '-317x2675y1073z',
                90: '-34x11y2899z',
                91: '-354x933y2722z',
                92: '-407x1806y2231z',
                93: '-414x938y2712z',
                94: '-416x1961y2094z',
                95: '-459x2665y1046z',
                96: '-474x939y2702z',
                97: '-507x1803y2213z',
                98: '-524x1957y2074z',
                99: '-536x936y2691z',
                100: '-599x929y2680z',
                101: '-600x2647y1019z',
                102: '-608x1795y2194z',
                103: '-632x1946y2054z',
                104: '-63x17y2899z',
                105: '-663x918y2669z',
                106: '-6x2y2899z',
                107: '-709x1781y2175z',
                108: '-727x903y2657z',
                109: '-740x1930y2033z',
                110: '-740x2622y992z',
                111: '-791x884y2646z',
                112: '-810x1761y2156z',
                113: '-849x1907y2012z',
                114: '-854x860y2634z',
                115: '-87x856y2769z',
                116: '-880x2589y965z',
                117: '-911x1735y2136z',
                118: '-918x832y2621z',
                119: '-92x20y2898z',
                120: '-956x1877y1991z',
                121: '-980x799y2609z'}

shot2five30004xi = {
                1: '-1014x826y2699z',
                2: '-1047x1762y2189z',
                3: '-1053x2636y970z',
                4: '-1078x788y2686z',
                5: '-1100x1905y2038z',
                6: '-1140x745y2672z',
                7: '-1150x1723y2169z',
                8: '-1193x2586y941z',
                9: '-1200x698y2658z',
                10: '-1209x1862y2016z',
                11: '-1251x1678y2148z',
                12: '-1259x646y2644z',
                13: '-125x20y2997z',
                14: '-1315x590y2630z',
                15: '-1317x1813y1994z',
                16: '-1331x2528y913z',
                17: '-1351x1627y2127z',
                18: '-1369x530y2616z',
                19: '-140x908y2855z',
                20: '-1419x466y2601z',
                21: '-1422x1757y1971z',
                22: '-1449x1569y2106z',
                23: '-1466x2462y884z',
                24: '-1467x398y2586z',
                25: '-1511x326y2570z',
                26: '-1525x1694y1949z',
                27: '-1544x1506y2084z',
                28: '-1551x250y2555z',
                29: '-156x17y2995z',
                30: '-1588x172y2539z',
                31: '-1598x2390y855z',
                32: '-1620x90y2523z',
                33: '-1626x1626y1926z',
                34: '-1636x1437y2062z',
                35: '-1647x5y2506z',
                36: '-1723x1551y1903z',
                37: '-1725x1362y2041z',
                38: '-1726x2309y827z',
                39: '-1811x1281y2019z',
                40: '-1816x1471y1879z',
                41: '-1850x2222y798z',
                42: '-187x10y2994z',
                43: '-1892x1196y1996z',
                44: '-1906x1385y1856z',
                45: '-194x927y2846z',
                46: '-1969x2128y769z',
                47: '-1970x1105y1974z',
                48: '-1991x1293y1832z',
                49: '-2042x1009y1951z',
                50: '-2072x1196y1808z',
                51: '-2083x2027y740z',
                52: '-2110x908y1928z',
                53: '-212x2019y2208z',
                54: '-2148x1094y1784z',
                55: '-2173x803y1905z',
                56: '-217x1y2992z',
                57: '-2192x1920y711z',
                58: '-2219x987y1760z',
                59: '-2230x694y1882z',
                60: '-2281x581y1858z',
                61: '-2284x876y1736z',
                62: '-2295x1807y681z',
                63: '-2327x464y1835z',
                64: '-2343x761y1711z',
                65: '-2366x344y1811z',
                66: '-2392x1688y652z',
                67: '-2396x642y1686z',
                68: '-2399x222y1787z',
                69: '-2442x519y1662z',
                70: '-2482x1564y623z',
                71: '-2483x393y1637z',
                72: '-249x943y2836z',
                73: '-2506x100y1821z',
                74: '-2516x264y1611z',
                75: '-2542x133y1586z',
                76: '-2561x0y1560z',
                77: '-2566x1435y593z',
                78: '-2643x1301y564z',
                79: '-2712x1164y535z',
                80: '-2774x1022y505z',
                81: '-2829x877y475z',
                82: '-2875x728y446z',
                83: '-2914x578y416z',
                84: '-2944x425y386z',
                85: '-2966x271y357z',
                86: '-2979x115y327z',
                87: '-307x956y2826z',
                88: '-319x1865y2327z',
                89: '-321x2027y2187z',
                90: '-328x2767y1110z',
                91: '-35x11y2999z',
                92: '-367x965y2816z',
                93: '-421x1868y2308z',
                94: '-428x970y2806z',
                95: '-431x2029y2167z',
                96: '-475x2757y1082z',
                97: '-491x971y2795z',
                98: '-524x1866y2289z',
                99: '-542x2024y2146z',
                100: '-555x969y2784z',
                101: '-620x961y2773z',
                102: '-621x2738y1054z',
                103: '-629x1857y2270z',
                104: '-654x2013y2125z',
                105: '-65x17y2999z',
                106: '-686x950y2761z',
                107: '-733x1843y2250z',
                108: '-752x934y2749z',
                109: '-766x1996y2103z',
                110: '-766x2712y1026z',
                111: '-7x2y2999z',
                112: '-818x914y2737z',
                113: '-838x1822y2230z',
                114: '-878x1972y2082z',
                115: '-884x889y2725z',
                116: '-90x886y2864z',
                117: '-910x2678y998z',
                118: '-943x1795y2210z',
                119: '-949x860y2712z',
                120: '-95x20y2998z',
                121: '-989x1942y2060z'}         


shot2five31004xi = {
                1: '-1022x2007y2129z',
                2: '-1048x854y2789z',
                3: '-1082x1821y2262z',
                4: '-1088x2724y1002z',
                5: '-1114x814y2775z',
                6: '-1137x1969y2106z',
                7: '-1178x770y2761z',
                8: '-1188x1781y2241z',
                9: '-1233x2672y973z',
                10: '-1240x721y2747z',
                11: '-1250x1924y2083z',
                12: '-1293x1734y2220z',
                13: '-1301x668y2733z',
                14: '-130x21y3097z',
                15: '-1359x610y2718z',
                16: '-1361x1873y2060z',
                17: '-1376x2612y943z',
                18: '-1396x1681y2198z',
                19: '-1414x548y2703z',
                20: '-145x938y2950z',
                21: '-1467x481y2687z',
                22: '-1470x1815y2037z',
                23: '-1497x1622y2176z',
                24: '-1515x2545y914z',
                25: '-1516x411y2672z',
                26: '-1561x337y2656z',
                27: '-1576x1751y2014z',
                28: '-1595x1556y2154z',
                29: '-1603x259y2640z',
                30: '-161x17y3095z',
                31: '-1640x177y2624z',
                32: '-1651x2469y884z',
                33: '-1674x93y2607z',
                34: '-1680x1680y1990z',
                35: '-1691x1485y2131z',
                36: '-1702x5y2590z',
                37: '-1780x1603y1966z',
                38: '-1783x1407y2109z',
                39: '-1784x2386y854z',
                40: '-1871x1324y2086z',
                41: '-1877x1520y1942z',
                42: '-1911x2296y824z',
                43: '-193x11y3093z',
                44: '-1955x1235y2063z',
                45: '-1970x1431y1918z',
                46: '-200x958y2941z',
                47: '-2034x2199y794z',
                48: '-2035x1141y2040z',
                49: '-2058x1336y1893z',
                50: '-2110x1042y2016z',
                51: '-2141x1236y1869z',
                52: '-2152x2095y764z',
                53: '-2180x938y1992z',
                54: '-219x2087y2281z',
                55: '-2220x1131y1844z',
                56: '-2245x830y1969z',
                57: '-224x1y3091z',
                58: '-2265x1984y734z',
                59: '-2292x1020y1819z',
                60: '-2304x717y1945z',
                61: '-2357x600y1920z',
                62: '-2360x905y1794z',
                63: '-2371x1867y704z',
                64: '-2404x480y1896z',
                65: '-2421x786y1768z',
                66: '-2445x356y1871z',
                67: '-2471x1745y674z',
                68: '-2476x663y1743z',
                69: '-2479x229y1846z',
                70: '-2524x536y1717z',
                71: '-2565x1616y644z',
                72: '-2565x406y1691z',
                73: '-2586x103y1880z',
                74: '-258x975y2931z',
                75: '-2600x273y1665z',
                76: '-2627x137y1639z',
                77: '-2647x0y1612z',
                78: '-2651x1483y613z',
                79: '-2731x1345y583z',
                80: '-2803x1202y552z',
                81: '-2867x1056y522z',
                82: '-2923x906y491z',
                83: '-2971x753y461z',
                84: '-3011x597y430z',
                85: '-3042x439y399z',
                86: '-3065x280y368z',
                87: '-3079x119y338z',
                88: '-317x988y2921z',
                89: '-329x1927y2405z',
                90: '-331x2095y2260z',
                91: '-339x2859y1147z',
                92: '-36x12y3099z',
                93: '-379x997y2910z',
                94: '-435x1930y2385z',
                95: '-442x1002y2899z',
                96: '-445x2096y2239z',
                97: '-490x2849y1119z',
                98: '-507x1004y2888z',
                99: '-542x1928y2365z',
                100: '-560x2092y2217z',
                101: '-573x1001y2877z',
                102: '-641x2830y1090z',
                103: '-641x994y2865z',
                104: '-650x1919y2345z',
                105: '-676x2080y2195z',
                106: '-67x18y3099z',
                107: '-708x982y2853z',
                108: '-758x1904y2325z',
                109: '-777x966y2841z',
                110: '-791x2063y2173z',
                111: '-791x2803y1060z',
                112: '-7x2y3099z',
                113: '-845x945y2828z',
                114: '-866x1883y2304z',
                115: '-907x2038y2151z',
                116: '-913x919y2815z',
                117: '-93x915y2960z',
                118: '-940x2767y1031z',
                119: '-974x1855y2283z',
                120: '-981x889y2802z',
                121: '-98x21y3098z'}

shot2five32004xi = {
                1: '-1006x1915y2357z',
                2: '-1013x918y2893z',
                3: '-101x22y3198z',
                4: '-1055x2072y2198z',
                5: '-1082x882y2879z',
                6: '-1116x1880y2335z',
                7: '-1123x2811y1034z',
                8: '-1150x841y2865z',
                9: '-1173x2033y2174z',
                10: '-1216x795y2850z',
                11: '-1226x1838y2313z',
                12: '-1273x2758y1004z',
                13: '-1281x745y2836z',
                14: '-1290x1986y2151z',
                15: '-1335x1790y2291z',
                16: '-1343x689y2821z',
                17: '-134x21y3197z',
                18: '-1403x630y2805z',
                19: '-1405x1933y2127z',
                20: '-1420x2696y974z',
                21: '-1441x1735y2269z',
                22: '-1460x565y2790z',
                23: '-150x969y3046z',
                24: '-1514x497y2774z',
                25: '-1517x1874y2103z',
                26: '-1545x1674y2246z',
                27: '-1564x2627y943z',
                28: '-1565x424y2758z',
                29: '-1612x348y2742z',
                30: '-1627x1807y2079z',
                31: '-1647x1606y2223z',
                32: '-1655x267y2725z',
                33: '-167x18y3195z',
                34: '-1693x183y2708z',
                35: '-1705x2549y912z',
                36: '-1728x96y2691z',
                37: '-1734x1734y2054z',
                38: '-1745x1533y2200z',
                39: '-1757x5y2674z',
                40: '-1838x1655y2029z',
                41: '-1840x1453y2177z',
                42: '-1841x2463y882z',
                43: '-1931x1367y2153z',
                44: '-1938x1569y2005z',
                45: '-1973x2370y851z',
                46: '-199x11y3193z',
                47: '-2018x1275y2129z',
                48: '-2033x1477y1980z',
                49: '-207x989y3036z',
                50: '-2100x2270y820z',
                51: '-2101x1178y2105z',
                52: '-2124x1379y1954z',
                53: '-2178x1076y2081z',
                54: '-2210x1276y1929z',
                55: '-2222x2162y789z',
                56: '-2251x969y2057z',
                57: '-226x2154y2355z',
                58: '-2291x1167y1903z',
                59: '-2318x857y2032z',
                60: '-231x1y3191z',
                61: '-2338x2048y758z',
                62: '-2366x1053y1878z',
                63: '-2379x740y2007z',
                64: '-2433x620y1982z',
                65: '-2436x935y1852z',
                66: '-2448x1928y727z',
                67: '-2482x495y1957z',
                68: '-2499x812y1825z',
                69: '-2524x367y1932z',
                70: '-2551x1801y696z',
                71: '-2555x684y1799z',
                72: '-2559x237y1906z',
                73: '-2605x553y1772z',
                74: '-2648x1669y664z',
                75: '-2648x419y1746z',
                76: '-2667x106y1939z',
                77: '-266x1006y3025z',
                78: '-2684x282y1719z',
                79: '-2712x142y1692z',
                80: '-2732x0y1664z',
                81: '-2737x1531y633z',
                82: '-2819x1388y602z',
                83: '-2893x1241y570z',
                84: '-2959x1090y539z',
                85: '-3017x935y507z',
                86: '-3067x777y476z',
                87: '-3108x616y444z',
                88: '-3140x453y412z',
                89: '-3164x289y380z',
                90: '-3178x123y349z',
                91: '-327x1020y3015z',
                92: '-340x1989y2483z',
                93: '-342x2162y2333z',
                94: '-350x2951y1184z',
                95: '-38x12y3199z',
                96: '-391x1029y3004z',
                97: '-449x1993y2462z',
                98: '-457x1035y2993z',
                99: '-460x2164y2311z',
                100: '-506x2940y1155z',
                101: '-524x1036y2981z',
                102: '-559x1990y2442z',
                103: '-578x2159y2289z',
                104: '-592x1033y2969z',
                105: '-661x1026y2957z',
                106: '-662x2921y1125z',
                107: '-671x1981y2421z',
                108: '-697x2148y2266z',
                109: '-69x18y3199z',
                110: '-731x1014y2945z',
                111: '-782x1966y2400z',
                112: '-7x2y3199z',
                113: '-802x997y2932z',
                114: '-817x2129y2244z',
                115: '-817x2893y1095z',
                116: '-872x975y2919z',
                117: '-894x1944y2379z',
                118: '-936x2104y2221z',
                119: '-943x949y2906z',
                120: '-96x945y3055z',
                121: '-971x2856y1065z'}

shot2five33004xi = {
                1: '-1001x2946y1098z',
                2: '-1037x1975y2431z',
                3: '-1044x946y2983z',
                4: '-104x22y3298z',
                5: '-1088x2136y2266z',
                6: '-1116x909y2969z',
                7: '-1151x1939y2408z',
                8: '-1158x2899y1067z',
                9: '-1186x867y2954z',
                10: '-1210x2096y2242z',
                11: '-1254x820y2939z',
                12: '-1265x1896y2386z',
                13: '-1313x2844y1035z',
                14: '-1321x768y2924z',
                15: '-1330x2049y2218z',
                16: '-1376x1846y2363z',
                17: '-1385x711y2909z',
                18: '-138x22y3297z',
                19: '-1447x649y2893z',
                20: '-1449x1994y2193z',
                21: '-1464x2781y1004z',
                22: '-1486x1789y2340z',
                23: '-1506x583y2877z',
                24: '-155x999y3141z',
                25: '-1561x512y2861z',
                26: '-1565x1932y2169z',
                27: '-1593x1726y2316z',
                28: '-1613x2709y973z',
                29: '-1614x438y2844z',
                30: '-1662x358y2827z',
                31: '-1678x1864y2144z',
                32: '-1698x1657y2293z',
                33: '-1706x275y2810z',
                34: '-172x18y3295z',
                35: '-1746x189y2793z',
                36: '-1758x2629y941z',
                37: '-1782x99y2775z',
                38: '-1788x1788y2118z',
                39: '-1800x1581y2269z',
                40: '-1812x5y2757z',
                41: '-1895x1706y2093z',
                42: '-1898x1498y2245z',
                43: '-1899x2540y909z',
                44: '-1992x1410y2220z',
                45: '-1998x1618y2067z',
                46: '-2035x2444y878z',
                47: '-205x11y3293z',
                48: '-2081x1315y2196z',
                49: '-2097x1523y2041z',
                50: '-213x1020y3130z',
                51: '-2166x2341y846z',
                52: '-2167x1215y2171z',
                53: '-2191x1422y2015z',
                54: '-2247x1110y2146z',
                55: '-2279x1316y1989z',
                56: '-2291x2230y814z',
                57: '-2321x999y2121z',
                58: '-233x2221y2428z',
                59: '-2363x1204y1963z',
                60: '-2390x883y2096z',
                61: '-239x1y3291z',
                62: '-2411x2112y782z',
                63: '-2440x1086y1936z',
                64: '-2453x763y2070z',
                65: '-2510x639y2044z',
                66: '-2512x964y1909z',
                67: '-2524x1988y750z',
                68: '-2559x511y2018z',
                69: '-2577x837y1882z',
                70: '-2603x379y1992z',
                71: '-2631x1857y717z',
                72: '-2635x706y1855z',
                73: '-2639x244y1966z',
                74: '-2687x571y1828z',
                75: '-2730x1721y685z',
                76: '-2731x432y1800z',
                77: '-2748x109y1998z',
                78: '-274x1038y3120z',
                79: '-2768x290y1772z',
                80: '-2797x146y1745z',
                81: '-2818x0y1716z',
                82: '-2822x1579y653z',
                83: '-2907x1432y621z',
                84: '-2983x1280y588z',
                85: '-3052x1124y556z',
                86: '-3112x964y523z',
                87: '-3163x801y490z',
                88: '-3205x636y458z',
                89: '-3238x468y425z',
                90: '-3262x298y392z',
                91: '-3277x127y360z',
                92: '-338x1052y3109z',
                93: '-351x2051y2560z',
                94: '-353x2230y2406z',
                95: '-361x3044y1221z',
                96: '-39x12y3299z',
                97: '-403x1061y3098z',
                98: '-463x2055y2539z',
                99: '-471x1067y3086z',
                100: '-474x2232y2383z',
                101: '-522x3032y1191z',
                102: '-540x1069y3074z',
                103: '-577x2052y2518z',
                104: '-596x2227y2360z',
                105: '-610x1065y3062z',
                106: '-682x1058y3050z',
                107: '-683x3012y1160z',
                108: '-691x2043y2497z',
                109: '-719x2215y2337z',
                110: '-71x19y3299z',
                111: '-754x1045y3037z',
                112: '-7x3y3299z',
                113: '-807x2027y2475z',
                114: '-827x1028y3024z',
                115: '-843x2196y2314z',
                116: '-843x2983y1129z',
                117: '-900x1006y3011z',
                118: '-922x2004y2453z',
                119: '-966x2170y2290z',
                120: '-972x978y2997z',
                121: '-99x974y3151z'}

      
#"
#"/>
    
# -------------------------------------------------------------------------------------------------
#<function4xi function = "shoot2five4xi" usage = "creating spheres">
#<state4xi status = "ACK4tagging; ACK4moduletesting; NACK4systemtesting"/>
# -------------------------------------------------------------------------------------------------
def shoot2five4xi(queue2five = None, consumer_channel2five = None, publisher_channel2five = None,
             start2distance = None, interval2distance = None, max2layer = None, marginal2layer = None, max2count = None,
             marginal2count = None, sign2x = None, sign2y = None, sign2z = None, max2iterate = None,
             start2plusa = None, max2plusa = None, min2plusa = None, start2minusa = None, max2minusa = None, min2minusa = None,
             start2pluse = None, max2pluse = None, min2pluse = None, start2minuse = None, max2minuse = None, min2minuse = None,
             increase2distance = None, change2a = None, change2e = None, increase2a = None, increase2e = None ):
    '''
    shoots according to required parameters
    '''
    
    # -------------------------------------------------------------------------------------------------
    # PARAMETERS                   
    # -------------------------------------------------------------------------------------------------                                                               
    
    time2start = time4xi()
    print("\n (STEP 1A0/33) OF SHOOT2FIVE4XI - STARTED TIME: ", time2start) 
    
    print("\n (STEP 1A2/33) OF SHOOT2FIVE4XI -  QUEUE2FIVE: ", queue2five)      
    # 
    
    print("\n (STEP 1A3/33) OF SHOOT2FIVE4XI -  CONSUMER_CHANNEL2FIVE: ", consumer_channel2five)
    # 
          
    print("\n (STEP 1A4/33) OF SHOOT2FIVE4XI -  PUBLISHER_CHANNEL2FIVE: ", publisher_channel2five)          
    # 
      
    
    print("\n (STEP 1A5/33) OF SHOOT2FIVE4XI -  START TO DISTANCE: ", start2distance) 
    print("\n (STEP 1A6/33) OF SHOOT2FIVE4XI -  INTERVAL TO DISTANCE: ", interval2distance)
    print("\n (STEP 1A7/33) OF SHOOT2FIVE4XI -  MAX TO LAYER: ", max2layer)    
    print("\n (STEP 1A8/33) OF SHOOT2FIVE4XI -  MARGINAL TO LAYER: ", marginal2layer)
    print("\n (STEP 1A9/33) OF SHOOT2FIVE4XI -  SIGN TO X: ", sign2x)       
    print("\n (STEP 1A10/33) OF SHOOT2FIVE4XI -  SIGN TO Y: ", sign2y)
    print("\n (STEP 1A11/33) OF SHOOT2FIVE4XI -  SIGN TO Z: ", sign2z)    
    print("\n (STEP 1A12/33) OF SHOOT2FIVE4XI -  START TO PLUS AZIMUTH: ", start2plusa)
    print("\n (STEP 1A13/33) OF SHOOT2FIVE4XI -  MAX TO PLUS AZIMUTH: ", max2plusa)       
    print("\n (STEP 1A14/33) OF SHOOT2FIVE4XI -  MIN TO PLUS AZIMUTH: ", min2plusa)
    print("\n (STEP 1A15/33) OF SHOOT2FIVE4XI -  START TO MINUS AZIMUTH: ", start2minusa)
    print("\n (STEP 1A16/33) OF SHOOT2FIVE4XI -  MAX TO MINUS AZIMUTH: ", max2minusa)
    print("\n (STEP 1A17/33) OF SHOOT2FIVE4XI -  MIN TO MINUS AZIMUTH: ", min2minusa)    
    print("\n (STEP 1A18/33) OF SHOOT2FIVE4XI -  START TO PLUS ELEVATION: ", start2pluse)
    print("\n (STEP 1A19/33) OF SHOOT2FIVE4XI -  MAX TO PLUS ELEVATION: ", max2pluse)
    print("\n (STEP 1A20/33) OF SHOOT2FIVE4XI -  MIN TO PLUS ELEVATION: ", min2pluse)
    print("\n (STEP 1A21/33) OF SHOOT2FIVE4XI -  START TO MINUS ELEVATION: ", start2minuse) 
    print("\n (STEP 1A22/33) OF SHOOT2FIVE4XI -  MAX TO MINUS ELEVATION: ", max2minuse)
    print("\n (STEP 1A23/33) OF SHOOT2FIVE4XI -  MIN TO MINUS ELEVATION: ", min2minuse)
    print("\n (STEP 1A24/33) OF SHOOT2FIVE4XI -  INCREASE TO DISTANCE: ", increase2distance)
    print("\n (STEP 1A25/33) OF SHOOT2FIVE4XI -  CHANGE TO AZIMUTH: ", change2a) 
    print("\n (STEP 1A26/33) OF SHOOT2FIVE4XI -  CHANGE TO ELEVATION: ", change2e)           
    print("\n (STEP 1A27/33) OF SHOOT2FIVE4XI -  INCREASE TO AZIMUTH: ", increase2a)  
    print("\n (STEP 1A28/33) OF SHOOT2FIVE4XI -  INCREASE TO ELEVATION: ", increase2e)  
                                                      
    # =================================================================================================                   
    # INITIALIZATIONS
    # =================================================================================================         
    print("\n (STEP 2A/33) OF SHOOT2FIVE4XI - INITIALIZING SPHERE4XI ") 
        
    # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
    # SPHERE2XI USING FUNCTION
    # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
    
    init_sphere2five4xi(message2sphere = "shoot4core", message2shot = 'shoot4skeleton')
    print("\n (STEP 2C/33) OF SHOOT2FIVE4XI - PEFORMED INIT_SPHERE2FIVE4XI")     

    # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
    # DISTANCE
    # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~                                        
    if start2distance is None:
        start2distance = 100
    start2distance4xi = int(start2distance)
    print("\n (STEP 3A/33) OF SHOOT2FIVE4XI - START2DISTANCE4XI: ", start2distance4xi)
    # 
    
    # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
    # INTERVAL
    # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~                     
    if interval2distance is None:
        interval2distance = 100
    interval2distance4xi = int(interval2distance)  
    print("\n (STEP 4A/33) OF SHOOT2FIVE4XI - INTERVAL TO DISTANCE: ", interval2distance4xi)
    # 
    
    # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
    # MAX PER LAYER WITH MARGINAL
    # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
    if max2layer is None:
        max2layer = 100
    max2layer4xi = int(max2layer)
    
    if marginal2layer is None:                              
        marginal2layer = 1.2
    marginal2layer4xi = marginal2layer
        
    omax2layer4xi = max2layer4xi
    
    max2layer4xi = int(marginal2layer4xi * max2layer4xi)
    print("\n (STEP 5A/33) OF SHOOT2FIVE4XI - MAXIMUM SHOTS PER LAYER: ", max2layer4xi, " WITH MARGINAL TO LAYER: ", marginal2layer4xi) 
    # 
                                  
    # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
    # MAX SHOTS WITH MARGINAL
    # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
    if max2count is None:
        max2count = 100
    max2count4xi = int(max2count) 
         
    if marginal2count is None:    
        marginal2count = 1.2
    marginal2count4xi = marginal2count     
        
    omax2count4xi = max2count4xi
    
    max2count4xi = int(marginal2count4xi * max2count4xi)
            
    print("\n (STEP 6A/33) OF SHOOT2FIVE4XI - MAXIMUM SHOTS: ", max2count4xi, " MARGINAL TO COUNT: ", marginal2count4xi) 
    # 

    # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
    # TIME
    # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~                    
    time2start4xi = time4xi()                        
    print("\n (STEP 7A/33) OF SHOOT2FIVE4XI - START TIME: ", time2start4xi)
    # 
                                                                               
    # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
    # REQUIRED SIGNS FOR (X,Y,Z)
    # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
    if sign2x is None:
        sign2x = '+' 
    sign2x4xi = sign2x
           
    if sign2y is None:
        sign2y = '+'
    sign2y4xi = sign2y    
    if sign2z is None:    
        sign2z = '+'
    sign2z4xi = sign2z
        
    print("\n (STEP 8A/33) OF SHOOT2FIVE4XI - X-SIGN: ", sign2x4xi, 'Y-SIGN: ', sign2y4xi, 'Z-SIGN: ', sign2z4xi)
    #     
         
                              
    # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
    # ITERATIONS 
    # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~                    
    if max2iterate is None:
        max2iterate = max2count * 21                                # success ratio may be less than 9% 
    max2iterate4xi = max2iterate
    print("\n (STEP 9A/33) OF SHOOT2FIVE4XI - MAXIMUM TO ITERATIONS: ", max2iterate4xi) 
    # 
      
    # =================================================================================================                   
    # AZIMUTH
    # =================================================================================================                
                          
    # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
    # azimuth and elevation angle initialized
    # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
    # ref: http://en.wikipedia.org/wiki/Radian#Conversion_between_radians_and_degrees
    # one radian is equal to 180/p degrees <=> 1 deg = rad * 180 / pi                             
    # pi/6 = 30, pi/4 = 45, pi/3 = 60, pi/2 = 90, 2/3*pi = 120, 3/4pi=135, 5/6*pi = 150, pi = 180
    # 7/6*pi = 210, 5/4*pi = 225...3*pi/2 = 270, 5*pi/3 = 300 ... 2*pi = 0 or 360 degrees
    # I   = 0...90    (0...pi/2) :     sin+, cos+
    # II  = 90...180  (pi/2...pi):     sin+, cos- 
    # III = 180...270 (pi...3*pi/2):   sin-, cos-
    # IV  = 270...360 (3*pi/2...2*pi): sin-, cos+
    # ref: http://en.wikipedia.org/wiki/Azimuth
                                                            
    # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
    # 
    # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~                        
    if start2plusa is None:
        start2plusa = pi/6                      # start plus azimuth 30 degrees - iterates smaller
    start2plusa4xi = start2plusa                                                               
    print("\n (STEP 10A/33) OF SHOOT2FIVE4XI - START TO PLUS AZIMUTH: ", start2plusa4xi) 
    # 
                                     
    # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
    # 
    # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~                       
    if max2plusa is None:
        max2plusa = 2*pi                        # extreme plus azimuth 360 degrees around sideways
    max2plusa4xi = max2plusa    
    print("\n (STEP 10B/33) OF SHOOT2FIVE4XI - MAX TO PLUS AZIMUTH: ", max2plusa4xi) 
    # 
                                                         
    # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
    # 
    # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~   
    if min2plusa is None:
        min2plusa = pi/240                      # minum positive azimuth 0.75 degrees sideways 
    min2plusa4xi = min2plusa    
    print("\n (STEP 10C/33) OF SHOOT2FIVE4XI - MIN TO PLUS AZIMUTH: ", min2plusa4xi) 
    #                                  
                              
    # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
    # 
    # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~                        
    if start2minusa is None:
        start2minusa = -pi/6                    # start minus azimuth -30 degrees sideways 
    start2minusa4xi = start2minusa
                                                                  
    print("\n (STEP 10D/33) OF SHOOT2FIVE4XI - START TO MINUS AZIMUTH: ", start2minusa4xi) 
    # 
                  
    # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
    # 
    # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~                       
    if max2minusa is None:
        max2minusa = -0.98*2*pi                 # extreme minus azimuth almost -360 degrees 
    max2minusa4xi = max2minusa    
    print("\n (STEP 10E/33) OF SHOOT2FIVE4XI - MAX TO MINUS AZIMUTH: ", max2minusa4xi) 
    # 
                                                            
    # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
    # 
    # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~   
    if min2minusa is None:
        min2minusa = -pi/240                    # nearest to zero minus to azimuth
    min2minusa4xi = min2minusa    
    print("\n (STEP 10F/33) MIN TO MINUS AZIMUTH: ", min2minusa4xi) 
    # 

    # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
    # 
    # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~   
    if increase2a is None:
        increase2a = 0.01                       # increase to azimuth
    increase2a4xi = increase2a    
    print("\n (STEP 10G/33) INCREASE2A4XI: ", increase2a4xi)     
    # 
                                                          
    # =================================================================================================                   
    # ELEVATION
    # =================================================================================================                
                                      
    # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
    # 
    # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~                        
    if start2pluse is None:
        start2pluse = pi/6                      # start plus elevation 30 degrees up 
    start2pluse4xi = start2pluse    
    print("\n (STEP 11A/33) OF SHOOT2FIVE4XI - START TO PLUS ELEVATION: ", start2pluse4xi) 
    # 
                                          
    # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
    # 
    # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~                       
    if max2pluse is None:
        max2pluse = pi                          # most flexible elevation 180 degrees 
    max2pluse4xi = max2pluse    
    print("\n (STEP 11B/33) OF SHOOT2FIVE4XI - MAX TO PLUS ELEVATION: ", max2pluse4xi) 
    # 
                      
    # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
    # 
    # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~   
    if min2pluse is None:
        min2pluse = pi/240                      # lowest plus to elevation 0.75 degrees                          
    min2pluse4xi = min2pluse    
    print("\n (STEP 11C/33) OF SHOOT2FIVE4XI - MIN TO PLUS ELEVATION: ", min2pluse4xi) 
    # 
                                   
    # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
    # 
    # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~                        
    if start2minuse is None:
        start2minuse = -pi/6                    # start minus elevation -30 degrees down                                                
    start2minuse4xi = start2minuse    
    print("\n (STEP 11D/33) OF SHOOT2FIVE4XI - START TO MINUS ELEVATION: ", start2minuse4xi) 
    # 
    
    # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
    # 
    # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~                      
    if max2minuse is None:
        max2minuse = -0.98*pi                   # most painful minus elevation almost -180 degrees
    max2minuse4xi = max2minuse    
    print("\n (STEP 11E/33) OF SHOOT2FIVE4XI - MAX TO MINUS ELEVATION: ", max2minuse4xi) 
    # 
                                                
    # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
    # 
    # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~   
    if min2minuse is None:
        min2minuse = -pi/240                    # least painful minus elevation -0.75 degrees
    min2minuse4xi = min2minuse                                  
    print("\n (STEP 11F/33) OF SHOOT2FIVE4XI - MIN TO MINUS ELEVATION: ", min2minuse4xi) 
    # 


    # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
    # 
    # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~   
    if increase2e is None:
        increase2e = 0.01                       # increase to elevation
    increase2e4xi = increase2e    
    print("\n (STEP 11G/33) INCREASE2E4XI: ", increase2e4xi)     
    #     
                                               
    # =================================================================================================      
    # ALGORITHM TUNING 
    # =================================================================================================      
                                         
    # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
    # DISTANCE INCREMENTS 
    # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
        
    if increase2distance is None:
        increase2distance = 1                   # used to control number of shots per layer
    increase2distance4xi = int(increase2distance)    
    print("\n (STEP 12A/33) OF SHOOT2FIVE4XI - INCREASE TO DISTANCE: ", increase2distance4xi) 
    # 
                                         
    # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
    # AZIMUTH CHANGES 
    # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
    
    if change2a is None: 
        change2a = pi / 60                      # 3 degrees change to azimuth
    change2a4xi = change2a    
    print("\n (STEP 12B/33) OF SHOOT2FIVE4XI - CHANGE TO AZIMUTH: ", change2a4xi) 
    # 
                                        
    # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
    # ELEVATION CHANGES 
    # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
    if change2e is None:
        change2e = pi / 60                      # 3 degrees change to elevation
    change2e4xi = change2e    
    print("\n (STEP 12C/33) OF SHOOT2FIVE4XI - CHANGE TO ELEVATION: ", change2e4xi) 
    # 
                                                                                                                                      
    # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
    # AZIMUTH SETTINGS BASED ON SIGN, WHICH MIGHT GET TUNED TO OPPOSITE SIGN LATER ON
    # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
    sign2a4xi = '+'
    if sign2a4xi == '+':
        start2a4xi = start2plusa4xi
        min2a4xi = min2plusa4xi
        max2a4xi = max2plusa4xi
    else:
        start2a4xi = start2minusa4xi
        min2a4xi = min2minusa4xi
        max2a4xi = max2minusa4xi
        
    print("\n (STEP 14/33) OF SHOOT2FIVE4XI - START AZIMUTH: ", start2a4xi, 'MIN AZIMUTH: ', min2a4xi, 'MAX AZIMUTH: ', max2a4xi) 
    # 
                                                                                                                   
    # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
    # ELEVATION SETTINGS BASED ON SIGN, WHICH MIGHT GET TUNED TO OPPOSITE SIGN LATER ON
    # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
    sign2e4xi = '+'
    if sign2e4xi == '+':
       start2e4xi = start2pluse4xi
       min2e4xi = min2pluse4xi
       max2e4xi = max2pluse4xi
    else:
       start2e4xi = start2minuse4xi
       min2e4xi = min2minuse4xi
       max2e4xi = max2minuse4xi
            
    print("\n (STEP 15/33) OF SHOOT2FIVE4XI - START ELEVATION: ", start2e4xi, 'MIN ELEVATION: ', min2e4xi, 'MAX ELEVATION: ', max2e4xi) 
    # 
                                                                                                                    
    # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
    # AZIMUTH START SETTING
    # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~                                              
    a2shot4xi = start2a4xi 
                                                                                                                    
    # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
    # ELEVATION START SETTING
    # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~                                              
    e2shot4xi = start2e4xi                            
                                                                                                              
    # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
    # DISTANCE START SETTING
    # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~                          
    d2shot4xi = start2distance4xi

    print("\n (STEP 16/33) OF SHOOT2FIVE4XI - START AZIMUTH: ", a2shot4xi, ' START ELEVATION: ', e2shot4xi, ' START DISTANCE: ', d2shot4xi) 
    # 
           
    # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
    # initializations for while loop 
    # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
    count2shot = 0                                   # shots
    
    count2layer = 1                                  # layers                                                           
    
    count2ok = 0                                     # ok shots with all of (x,y,z) ok 
    
    count2distance = 0                               # measures shot per layer                       
    
    count2iterate = 0                                # hunting for right (x,y,z) combination
    
    count2rejected = 0                               # rejected
    
    ack2x = False                                    # validation for x-coordinate
    nack2x = True
    
    ack2y = False                                    # validation for y-coordinate
    nack2y = True                    
    
    ack2z = False                                    # validation for z-coordinate
    nack2z = True
    
    print("\n (STEP 17A/33) OF SHOOT2FIVE4XI - START TIME OF SHOOTING: ", time4xi(), " FOR ", max2count4xi, " SHOTS")
    # 
    print("\n (STEP 17B/33) OF SHOOT2FIVE4XI - COUNT2OK: ", count2ok, " MAX2COUNT4XI: ", max2count4xi, " COUNT2ITERATE: ", count2iterate, " MAX2ITERATE4XI: ", max2iterate4xi)
    # 
       
    # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
    # 
    # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
                                             
    while ((count2ok <= max2count4xi) and (count2iterate < max2iterate4xi)):   
        # ok shots staying less or equal to that of required amount & iterations not exceeding maximum  
            
        # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
        # 
        # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
        count2iterate = count2iterate + 1    
        
        
        # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
        # AZIMUTH CHANGES
        # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
        if a2shot4xi >= 0:        
            a2shot4xi = a2shot4xi + change2a4xi
            if a2shot4xi >= max2a4xi:
                start2a4xi = start2a4xi * 1.01
                a2shot4xi = start2a4xi 
                print("\n (STEP 18A/33) OF SHOOT2FIVE4XI - AZIMUTH BECAME BIGGER THAN MAXIMUM: ", max2a4xi , " NEW AZIMUTH: ", a2shot4xi)    
        else:
            a2shot4xi = a2shot4xi - change2a4xi
            if a2shot4xi <= min2a4xi:
                start2a4xi = start2a4xi * 1.01
                a2shot4xi = start2a4xi  
                print("\n (STEP 18B/33) OF SHOOT2FIVE4XI - AZIMUTH BECAME SMALLER THAN MINIMUM: ", min2a4xi , " NEW AZIMUTH: ", a2shot4xi)  
        
        print("\n (STEP 18C/33) OF SHOOT2FIVE4XI - AZIMUTH CHANGES CHECKED ")  
                
        # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
        # AZIMUTH ALGORITM CHECKING AGAINST MAXIMUM ALLOWED - RESTART WITH TUNING, IF NECESSARY
        # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~                        
        if (a2shot4xi >= 2*pi):
            sign2a4xi = '-'                                          # switch to negative
            change2a4xi = 0.98 * change2a4xi                         # change2a always positive
            start2a4xi = change2a4xi * start2minusa4xi               # new minus azimuth start
            a2shot4xi = start2a4xi                                   # new azimuth
            min2a4xi = min2minusa4xi                                 # new minimum to azimuth
            max2a4xi = max2minusa4xi                                 # new maximum to azimuth
            print("\n (STEP 19/33) OF SHOOT2FIVE4XI - AZIMUTH BECAME BIGGER THAN 2*PI , NEW AZIMUTH: ", a2shot4xi) 
             
        # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
        # AZIMUTH ALGORITM CHECKING AGAINST MINIMUM ALLOWED- RESTART WITH TUNING, IF NECESSARY
        # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~                             
        if (a2shot4xi <= -2*pi):
            sign2a4xi = '+'                                          # switch to positive
            change2a4xi = 0.98 * change2a4xi                         # change2a always positive
            start2a4xi = change2a4xi * start2plusa4xi                # new positive azimuth start
            a2shot4xi = start2a4xi                                   # new azimuth
            min2a4xi = min2plusa4xi                                  # new minimum to azimuth
            max2a4xi = max2plusa4xi                                  # new maximum to azimuth
            print("\n (STEP 20A/33) OF SHOOT2FIVE4XI - AZIMUTH BECAME LESS THAN -2*PI, NEW AZIMUTH: ", a2shot4xi) 
        
        print("\n (STEP 20B/33) OF SHOOT2FIVE4XI - AZIMUTH MAX AND MINIMUM CHANGES CHECKED ")       
    
        # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
        # ELEVATION CHANGES
        # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
        if e2shot4xi <= 0:
            e2shot4xi = e2shot4xi - increase2e4xi
            if e2shot4xi <= min2e4xi:
                change2e4xi = 1.02 * change2e4xi
                start2e4xi = change2e4xi * start2e4xi
                e2shot4xi = start2e4xi
                print("\n (STEP 21/33) OF SHOOT2FIVE4XI - ELEVATION BECAME LESS THAN MINIMUM: ", min2e4xi, " NEW ELEVATION: ", e2shot4xi)                                   
        else:
            e2shot4xi = e2shot4xi + increase2e4xi
            if e2shot4xi >= max2e4xi:
                change2e4xi = 1.08 * change2e4xi
                start2e4xi = change2e4xi * start2e4xi
                e2shot4xi = start2e4xi
                print("\n (STEP 22A/33) OF SHOOT2FIVE4XI - ELEVATION BECAME BIGGER THAN MAXIMUM: ", max2e4xi, " NEW ELEVATION: ", e2shot4xi)  
        
        print("\n (STEP 22B/33) OF SHOOT2FIVE4XI - ELEVATION CHANGES CHECKED ")                                                        
        
        # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
        # ELEVATION ALGORITM CHECKING AGAINST MAXIMUM ALLOWED - RESTART WITH TUNING, IF NECESSARY
        # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~                                                                   
        if (e2shot4xi >= pi):
            # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
            # start again with a new elevation and new elevation change
            # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
            sign2e4xi = '-'                                             # switch to negative
            change2e4xi = 0.98 * change2e4xi                            # change2e always positive
            start2e4xi = change2e4xi * start2minuse4xi                  # new minus elevation start
            e2shot4xi = start2e4xi                                      # new azimuth
            min2e4xi = min2minuse4xi                                    # new minimum to elevation
            max2e4xi = max2minuse4xi                                    # new maximum to elevation
            print("\n (STEP 23A/33) OF SHOOT2FIVE4XI - ELEVATION BECAME BIGGER THAN PI, NEW ELEVATION: ", e2shot4xi)
            
        print("\n (STEP 23B/33) OF SHOOT2FIVE4XI - ELEVATION MAX CHANGE CHECKED ") 
                        
        # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
        # ELEVATION ALGORITM CHECKING AGAINST MINIMUM ALLOWED- RESTART WITH TUNING, IF NECESSARY
        # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~                              
        
        if (e2shot4xi <= -pi):
            # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
            # start again with a new elevation and new elevation change
            # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~                            
            sign2e4xi = '+'                                             # switch to positive
            change2e4xi = 0.98 * change2e4xi                            # change2e always positive
            start2e4xi = change2e4xi * start2pluse4xi                   # new positive elevation start
            e2shot4xi = start2e4xi                                      # new azimuth
            min2e4xi = min2pluse4xi                                     # new minimum to elevation
            max2e4xi = max2pluse4xi                                     # new maximum to elevation        
            print("\n (STEP 24A/33) OF SHOOT2FIVE4XI - ELEVATION BECAME LESS THAN -PI, NEW ELEVATION: ", e2shot4xi)
            
        print("\n (STEP 24B/33) OF SHOOT2FIVE4XI - ELEVATION MIN CHANGE CHECKED ")         
    
        # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
        # SHOOT
        # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
        print("\n (STEP 25A/33) OF SHOOT2FIVE4XI - SETTING WITH SET_SPHERE2FIVE4XI")  
        print("\n A2SHOT4XI OF SHOOT2FIVE4XI: ", a2shot4xi)                       # 0.575958653158
        print("\n E2SHOT4XI OF SHOOT2FIVE4XI: ", e2shot4xi)                       # 0.533598775598  
        print("\n D2SHOT4XI OF SHOOT2FIVE4XI: ", d2shot4xi)                       # 100  
        print("\n INTERVAL2DISTANCE4XI OF SHOOT2FIVE4XI: ", interval2distance4xi) # 100
                                                                                 
        shot2xi = set_sphere2five4xi(azimuth2shot = a2shot4xi, elevation2shot = e2shot4xi, distance2shot = d2shot4xi, area2shot = int(4*pi*d2shot4xi**2/interval2distance4xi))
        
        print("\n (STEP 25B/33) OF SHOOT2FIVE4XI - PERFORMED SET_SPHERE2FIVE4XI, SPHERE4XI: ", shot2xi)  
        # 
            
        # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
        # CHECK THE SHOT 
        # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
        print("\n (STEP 25C/33) OF SHOOT2FIVE4XI - GETTING")  
        shot2examine = get_sphere2five4xi(id2shot = 'Yes', x2shot = 'Yes', y2shot = 'Yes', z2shot = 'Yes', azimuth2shot = 'Yes', elevation2shot = 'Yes', distance2shot = 'Yes', area2shot = 'Yes')
        
        print("\n (STEP 25D/33) OF SHOOT2FIVE4XI - PERFORMED GET")  
        # 
        
        print("\n (STEP 25E/33) OF SHOOT2FIVE4XI - SHOT TO EXAMINE ", count2shot, ": ", shot2examine)  
        # 
         
        keys2examine = shot2examine.keys()
        print("\n (STEP 26A/33) OF SHOOT2FIVE4XI - KEYS2EXAMINE: ", keys2examine)   
        # 
        
        for key2examine in sorted(keys2examine):
            print("\n (STEP 26B/33) OF SHOOT2FIVE4XI - KEY2EXAMINE ", key2examine)  
            # 
            
            ack2x = False 
            nack2x = True                                  
            # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
            # X OK ?
            # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~                        
            try:
                index2x=str.find(key2examine,'x')                               
                x2coordinate = int(key2examine[0:index2x])
                if x2coordinate >= 0:
                    if sign2x4xi == '+':
                        ack2x = True
                        nack2x = False
                        print("\n (STEP 27A/33) OF SHOOT2FIVE4XI - X2COORDINATE ACK: ", ack2x) 
                else:
                    if sign2x4xi == '-':
                        ack2x = True
                        nack2x = False
                        print("\n (STEP 27B/33) OF SHOOT2FIVE4XI - X2COORDINATE ACK: ", ack2x)
                         
            except:
                print("\n (STEP 27C/33) : *** FAILED WITH KEY2EXAMINE: ", key2examine)
                print("\n (STEP 27D/33) OF SHOOT4XI -INDEX2X: ", index2x)
                
            # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
            # Y OK ?
            # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~                              
            ack2y = False 
            nack2y = True     
            try:
                index2y=str.find(key2examine,'y')                               
                y2coordinate = int(key2examine[index2x+1:index2y])
                if y2coordinate >= 0:
                    if sign2y4xi == '+':
                        ack2y = True
                        nack2y = False
                        print("\n (STEP 27E/33) OF SHOOT2FIVE4XI - Y2COORDINATE ACK: ", ack2y)                                         
                else:
                    if sign2y4xi == '-':
                        ack2y = True
                        nack2y = False
                        print("\n (STEP 27F/33) OF SHOOT2FIVE4XI - Y2COORDINATE ACK: ", ack2y)                               
            except:
                print("\n (STEP 27G/33) OF SHOOT2FIVE4XI - *** FAILED WITH KEY2EXAMINE: ", key2examine)
                print("\n (STEP 27H/33) OF SHOOT2FIVE4XI - INDEX2Y: ", index2y)
                
            # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
            # Z OK ?
            # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~                              
            ack2z = False 
            nack2z = True                                 
            try:
                index2z=str.find(key2examine,'z')                               
                z2coordinate = int(key2examine[index2y+1:index2z])
                if z2coordinate >= 0:
                    if sign2z4xi == '+':
                        ack2z = True
                        nack2z = False
                        print("\n (STEP 27I/33) OF SHOOT2FIVE4XI - Z2COORDINATE ACK: ", ack2z)                                               
                else:
                    if sign2z4xi == '-':
                        ack2z = True
                        nack2z = False
                        print("\n (STEP 27J/33) OF SHOOT2FIVE4XI - Z2COORDINATE ACK: ", ack2z)                                  
            except:
                print("\n (STEP 27K/33) OF SHOOT2FIVE4XI - *** FAILED WITH KEY2EXAMINE: ", key2examine)
                print("\n (STEP 27L/33) OF SHOOT2FIVE4XI - INDEX2Z: ", index2z)
                
            # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
            # (X,Y,Z) OK ?
            # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~                              
            try:                                                           
                if ((ack2x is True) and (ack2y is True) and (ack2z is True)):
                    print("\n (STEP 27M1/33) OF SHOOT2FIVE4XI - OK: (" , x2coordinate, ",", y2coordinate, ",", z2coordinate, ")") 
                    # 
                    print("\n (STEP 27M2/33) OF SHOOT2FIVE4XI - EXPECTED: (" , sign2x4xi, ",", sign2y4xi, ",", sign2z4xi, ")") 
                    # 
                    count2ok = count2ok + 1 
                    print("\n (STEP 27M3/33) OF SHOOT2FIVE4XI - COUNT2OK: " , count2ok, " MAX2LAYER4Xi: ", max2layer4xi) 
                    
                    count2distance = count2distance + increase2distance4xi      # one more shot for this layer and distance
                    print("\n (STEP 27M4/33) OF SHOOT2FIVE4XI - COUNT2DISTANCE: " , count2distance, " MAX2LAYER4Xi: ", max2layer4xi)
                    # 
                    
                    if count2distance >= max2layer4xi:
                        d2shot4xi = d2shot4xi + interval2distance4xi            # distance for the next layer
                        count2distance = 0
                        count2layer = count2layer + 1 
                        print("\n (STEP 27M5/33) OF SHOOT2FIVE4XI - NEW LAYER NUMBER: ", count2layer, ' NEW DISTANCE: ', d2shot4xi)
                        # 
                    else:
                        pass 

                else:
                    print("\n (STEP 27P/33) OF SHOOT2FIVE4XI - REJECTED: (" , x2coordinate, ",", y2coordinate, ",", z2coordinate, ")")
                    print("\n (STEP 27Q/33) OF SHOOT2FIVE4XI - EXPECTED: (" , sign2x4xi, ",", sign2y4xi, ",", sign2z4xi, ")")
                    
                    count2rejected = count2rejected + 1
                    # 
                    # 
                    
                    
                    
                                        
            except:
                print("\n (STEP 27S/33) OF SHOOT2FIVE4XI - *** FAILED WITH KEY2EXAMINE: ", key2examine)
                print("\n (STEP 27T/33) OF SHOOT2FIVE4XI - INDEX2Z: ", index2z)
        
        # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
        # CONTINUE WHILE
        # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~                                    
        print("\n (STEP 28A/33) OF SHOOT2FIVE4XI - CONTINUING WHILE WITH:")
        print("\n COUNT2OK OF SHOOT2FIVE4XI: ", count2ok)
        print("\n COUNT2DISTANCE OF SHOOT2FIVE4XI: ", count2distance)   
        print("\n MAX2COUNT OF SHOOT2FIVE4XI: ", max2count4xi)                        
        print("\n COUNT2ITERATE OF SHOOT2FIVE4XI: ", count2iterate)
        print("\n MAX2ITERATE OF SHOOT2FIVE4XI: ", max2iterate4xi)                        

        
        # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
        # END OF WHILE
        # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
             
    # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
    # EXAMINE RESULTS AFTER WHILE
    # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
    time2end = time4xi()           
    print("\n (STEP 30A1/33) OF SHOOT2FIVE4XI - STATISTICS FOR SHOOTING, WHICH ENDED: ", time2end)                           
    print("\n SHOTS OK OF SHOOT2FIVE4XI: ", count2ok, " = ", int(100 * count2ok/max2count4xi), " %")                              
    print("\n SHOTS ORIGINALLY REQUIRED OF SHOOT2FIVE4XI: ", omax2count4xi)      
    print("\n ITERATIONS NEEDED OF SHOOT2FIVE4XI: ", count2iterate)                              
    print("\n ITERATIONS ALLOWED OF SHOOT2FIVE4XI: ", max2iterate4xi) 
    print("\n REJECTED OF SHOOT2FIVE4XI: ", count2rejected, " = ", int(100 * count2rejected/count2iterate), " %") 

    
    # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
    # SHOW RESULTS
    # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
           
    print("\n (STEP 30B1/33) OF SHOOT2FIVE4XI - WHOLE BALL AFTER ALL OPERATIONS AND WITH MAX2COUNT: ", max2count4xi, 'TIME PRINTED: ', time4xi())  
    
    sphere2return = {}                                                 # only ok shots returned
     
    sphere2show = get_sphere2five4xi()
    dict2keys = sphere2show.keys()
    # 
     
    print("\n (STEP 30B3/33) OF SHOOT2FIVE4XI - SHOOTING SAMPLE OF : ", max2count4xi, " SHOTS", "NUMBER OF LAYERS: ", count2layer, ' LATEST DISTANCE: ', d2shot4xi, ' INTERVAL2DISTANCE: ', interval2distance4xi)    
    # 

    # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
    # 
    # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
    
    count2plusx = 0
    count2plusy = 0
    count2plusz = 0
           
    count2minusx = 0
    count2minusy = 0
    count2minusz = 0
    
    count2accepted = 0
    count2rejected = 0
    
    order2key = 1
    
    # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
    # ANALYZE SUCCEEDED SHOTS
    # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
             
    for key2dict in sorted(dict2keys):
    
        # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
        # 
        # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
            
        try:
            index2x=str.find(key2dict,'x')                               
            x2coordinate = int(key2dict[0:index2x])
            # print("\n (STEP 31/33) X2COORDINATE: ",  x2coordinate)
            if x2coordinate >= 0:
                count2plusx = count2plusx + 1
            else:
                count2minusx = count2minusx + 1    
        except:
            print("\n (STEP 31A/33) OF SHOOT2FIVE4XI - *** FAILED WITH KEY2DICT: ", key2dict)
            print("\n (STEP 31B/33) OF SHOOT2FIVE4XI - INDEX2X: ", index2x)
            
    
        # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
        # 
        # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
                 
        try:                                   
            index2y=str.find(key2dict,'y')
            y2coordinate = int(key2dict[index2x+1:index2y])
            # print("\n (STEP 31/33) Y2COORDINATE: ",  y2coordinate)
            if y2coordinate >= 0:
                count2plusy = count2plusy + 1
            else:
                count2minusy = count2minusy + 1  
        except:
            print("\n (STEP 31C/33) OF SHOOT2FIVE4XI - : *** FAILED WITH KEY2DICT: ", key2dict) 
            print("\n (STEP 31D/33) OF SHOOT2FIVE4XI - INDEX2X: ", index2x)
            print("\n (STEP 31E/33) OF SHOOT2FIVE4XI - INDEX2Y: ", index2y)
    
        # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
        # 
        # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
             
        try:                                                                         
            index2z=str.find(key2dict,'z') 
            z2coordinate = int(key2dict[index2y+1:index2z])
            # print("\n (STEP 31/33) Z2COORDINATE: ",  z2coordinate)
            if z2coordinate >= 0:
                count2plusz = count2plusz + 1
            else:
                count2minusz = count2minusz + 1
        except:
            print("\n (STEP 31F/33) OF SHOOT2FIVE4XI - *** FAILED WITH KEY2DICT: ", key2dict)
            print("\n (STEP 31G/33) OF SHOOT2FIVE4XI - INDEX2X: ", index2x)
            print("\n (STEP 31H/33) OF SHOOT2FIVE4XI - INDEX2Y: ", index2y)
            print("\n (STEP 31I/33) OF SHOOT2FIVE4XI - INDEX2Z: ", index2z)
    
        # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
        # 
        # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
             
        ack2x = False    
        if ((x2coordinate >= 0) and (sign2x4xi == '+')):
            ack2x = True
        if ((x2coordinate <= 0) and (sign2x4xi == '-')):
            ack2x = True                        
    
        # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
        # 
        # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
             
        ack2y = False    
        if ((y2coordinate >= 0) and (sign2y4xi == '+')):
            ack2y = True
        if ((y2coordinate <= 0) and (sign2y4xi == '-')):
            ack2y = True     
    
        # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
        # 
        # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
             
        ack2z = False    
        if ((z2coordinate >= 0) and (sign2z4xi == '+')):
            ack2z = True
        if ((z2coordinate <= 0) and (sign2z4xi == '-')):
            ack2z = True     
        
        if ((ack2x is True) and (ack2y is True) and (ack2z is True)                                 # (x,y,z) combination ok
            and((fabs(x2coordinate) > 1) or (fabs(y2coordinate) > 1) or (fabs(z2coordinate) > 1))): # core and skeleton coordinates omitted
            count2accepted = count2accepted + 1                                                                                                      
            print("\n (STEP 31/33) OF SHOOT2FIVE4XI - ACCEPTANCE: ", count2accepted, " SHOT: ", order2key, ":", key2dict, " EXPECTED SIGNS: (" , sign2x4xi, ",", sign2y4xi, ",", sign2z4xi, ")") 
            # 
            
            sphere2return[key2dict] = sphere2show[key2dict]
            
        else:
            count2rejected = count2rejected + 1
            # 
                                        
        order2key = order2key +1 
    
        # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
        # end of for loop
        # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
          

    # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
    # STATISTICS
    # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
                  
    count2tried = count2accepted + count2rejected 
    
    sum2plus = count2plusz + count2plusy+ count2plusz
    sum2minus = count2minusx + count2minusy+ count2minusz
    sum2total = count2plusx + count2minusx # same also with y and z - coordinate exists only once
            
    print('=' *80)
    print("\n (STEP 32/33) OF SHOOT2FIVE4XI - STATISTICS FOR REQUIRED: ", max2count4xi, " SHOTS")     
    print("\n START TIME OF SHOOT2FIVE4XI: ", time2start)
    print("\n ACCEPTED OF SHOOT2FIVE4XI: ", count2accepted, " = ", int(100*count2accepted/order2key), " %")
    print("\n REJECTED OF SHOOT2FIVE4XI: ", count2rejected, " = ", int(100*count2rejected/order2key), " %")
   
    print("\n DISTIBUTION OF SHOOT2FIVE4XI X, Y AND Z: ") 
    print("\n +X OF SHOOT2FIVE4XI: ", count2plusx, " = ", int(100*count2plusx/sum2total), " %")
    print("\n -X OF SHOOT2FIVE4XI: ", count2minusx, " = ", int(100*count2minusx/sum2total), " %") 
   
    print("\n +Y OF SHOOT2FIVE4XI: ", count2plusy, " = ", int(100*count2plusy/sum2total), " %")
    print("\n -Y OF SHOOT2FIVE4XI: ", count2minusy, " = ", int(100*count2minusy/sum2total), " %") 
   
    print("\n +Z OF SHOOT2FIVE4XI: ", count2plusz, " = ", int(100*count2plusz/sum2total), " %")
    print("\n -Z OF SHOOT2FIVE4XI: ", count2minusz, " = ", int(100*count2minusz/sum2total), " %") 
              
    
    print("\n SUM2TOTAL OF SHOOT2FIVE4XI: ", sum2total, "SUCCESS-RATIO: ", int(100*count2accepted/max2count4xi), " %", " COUNT2LAYER: ", count2layer)
    print("\n START2DISTANCE OF SHOOT2FIVE4XI: ", start2distance4xi, " INTERVAL2DISTANCE: ", interval2distance4xi, " MAX2LAYER: ", max2layer4xi, " MAX2COUNT : ", max2count4xi)
    print("\n EXPECTED COORDINATE SIGNS OF SHOOT2FIVE4XI: (X"  , sign2x4xi, ",Y", sign2y4xi, ",Z", sign2z4xi, ")") 
    
    print("\n REASONING OF SHOOT2FIVE4XI: ") 
    if count2accepted >= omax2count4xi:
        print("\n OK SHOOTING OF SHOOT2FIVE4XI: ACCEPTED SHOTS ", count2accepted, " >= ", omax2count4xi, " ORIGINALLY REQUIRED, MARIGINAL: ", marginal2count4xi)
        # OK SHOOTING OF SHOOT2FIVE4XI: ACCEPTED SHOTS  121  >=  100  ORIGINALLY REQUIRED, MARIGINAL:  1.2 
    else:
        print("\n *** FAILED SHOOTING OF SHOOT2FIVE4XI: ACCEPTED SHOT ONLY: ", count2accepted, " < ", omax2count4xi, " REQUIRED !")                                    
    
    print("\n END TIME OF SHOOT2FIVE4XI: ", time2end)
    print('=' *80)
    
    # SUM2TOTAL OF SHOOT2FIVE4XI:  571 SUCCESS-RATIO:  92  %  COUNT2LAYER:  9
    # START2DISTANCE OF SHOOT2FIVE4XI:  10  INTERVAL2DISTANCE:  10  MAX2LAYER:  12  MAX2COUNT :  96
    # EXPECTED COORDINATE SIGNS OF SHOOT2FIVE4XI: (X - ,Y + ,Z + )
    # REASONING OF SHOOT2FIVE4XI: 
    # OK SHOOTING OF SHOOT2FIVE4XI: ACCEPTED SHOTS  89  >=  80  ORIGINALLY REQUIRED, MARIGINAL:  1.2
     
    # ================================================================================
    #  (STEP 32/33) OF SHOOT2FIVE4XI - STATISTICS FOR REQUIRED:  240  SHOTS
    #  START TIME OF SHOOT2FIVE4XI:  10:59:10 06/15/10 Pacific Daylight Time
    #  ACCEPTED OF SHOOT2FIVE4XI:  243  =  15  %
    #  REJECTED OF SHOOT2FIVE4XI:  1322  =  84  %
    #  DISTIBUTION OF SHOOT2FIVE4XI X, Y AND Z: 
    #  +X OF SHOOT2FIVE4XI:  553  =  35  %
    #  -X OF SHOOT2FIVE4XI:  1012  =  64  %
    #  +Y OF SHOOT2FIVE4XI:  501  =  32  %
    #  -Y OF SHOOT2FIVE4XI:  1064  =  67  %
    #  +Z OF SHOOT2FIVE4XI:  786  =  50  %
    #  -Z OF SHOOT2FIVE4XI:  779  =  49  %
    #  SUM2TOTAL OF SHOOT2FIVE4XI:  1565 SUCCESS-RATIO:  101  %  COUNT2LAYER:  3
    #  START2DISTANCE OF SHOOT2FIVE4XI:  100  INTERVAL2DISTANCE:  100  MAX2LAYER:  120  MAX2COUNT :  240
    #  EXPECTED COORDINATE SIGNS OF SHOOT2FIVE4XI: (X - ,Y + ,Z + )
    #  REASONING OF SHOOT2FIVE4XI: 
    #  OK SHOOTING OF SHOOT2FIVE4XI: ACCEPTED SHOTS  243  >=  200  ORIGINALLY REQUIRED, MARIGINAL:  1.2
    #  END TIME OF SHOOT2FIVE4XI:  10:59:50 06/15/10 Pacific Daylight Time
    # ================================================================================   
        
    # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
    # RETURN
    # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
    if queue2five is None:
        
        # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
        # DICTIONARY RETURNING
        # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
          
        print("\n (STEP 33A/33) OF SHOOT2FIVE4XI - RETURNING COORDINATE DICTIONARY AS VARIABLE")   
        return sphere2return
    else:
 
        # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
        # QUEUE RETURNING
        # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
        ack2put = False
        queue2five4xi = queue2five
        
        print("\n (STEP 33B/33) OF SHOOT2FIVE4XI - TRYING TO RETURN BY PUTTING COORDINATE DICTIONARY TO QUEUE2FIVE4XI: ", queue2five4xi, " - TIME: ", time4xi())  
        try:
            # -------------------------------------------------------------------------------------
            # PUT DICTIONARY TO QUEUE 
            # -------------------------------------------------------------------------------------                 
            queue2five4xi.put(sphere2return)
            print("\n (STEP 33C/33) OF SHOOT2FIVE4XI - SUCCEEDED TO PUT COORDINATE DICTIONARY TO QUEUE2FIVE4XI: ", queue2five4xi, " - TIME: ", time4xi()) 
            # 
            ack2put = True
        except:
            print("\n (STEP 33D/33) OF SHOOT2FIVE4XI *** FAILED TO PUT COORDINATE DICTIONARY TO QUEUE2FIVE4XI: ", queue2five4xi, " - TIME: ", time4xi()) 
        
        print("\n (STEP 33E/33) OF SHOOT2FIVE4XI - TRYING TO SEND INFORMATION OF PUT-OPERATION VIA PUBLISHER_CHANNEL2FIVE: ", publisher_channel2five, " - TIME: ", time4xi()) 
        
        
        print("\n (STEP 33E1/33E) OF SHOOT2FIVE4XI - TRYING TO WRITE DICTIONARY TO FILE - TIME: ", time4xi()) 
        try:                
            # ---------------------------------------------------------------------------------------------
            # WRITE SHOT TO FILE 
            # ---------------------------------------------------------------------------------------------
            path2file      = '..\\..\\txt\\shot2five4xi.txt'
            text2copyright = '<!-- Copyright Small & Smart - California, United States of America - All rights reserved. -->' + '\n'
       
            
            f2xi=open(path2file, 'w')
            print("\n (STEP 33E2/33E) OF SHOOT2FIVE4XI - OPENED FILE: ", path2file, " - TIME: ", time4xi())   
            # 
            
                                
            # ---------------------------------------------------------------------------------------------
            # START
            # ---------------------------------------------------------------------------------------------                 
            f2xi.write(text2copyright)
              
            # ---------------------------------------------------------------------------------------------
            # BODY
            # ---------------------------------------------------------------------------------------------                 
            keys2write = sorted(sphere2return.keys())

            for key2write in sorted(keys2write):
                line2write = str(key2write) + '\n'
                f2xi.write(line2write)            
                
                line2write = str(sphere2return[key2write]) + '\n'
                f2xi.write(line2write) 
                                
            # ---------------------------------------------------------------------------------------------
            # END
            # ---------------------------------------------------------------------------------------------                 
            f2xi.write(text2copyright)
                
            print("\n (STEP 33F/33) OF SHOOT2FIVE4XI -  WROTE SHOT2FIVE4XI - TIME: ", time4xi()) 

            # 

            
            # ---------------------------------------------------------------------------------------------
            # 
            # ---------------------------------------------------------------------------------------------                 
            f2xi.close()     
            print("\n (STEP 33G/33) OF SHOOT2FIVE4XI -  CLOSED SHOT2FIVE4XI - TIME: ", time4xi()) 
            # 
             
        except:
            print("\n (STEP 33X/33) OF SHOOT2FIVE4XI *** FAILED TO WRITE SHOT2FIVE4XI - TIME: ", time4xi())
        
                      
             
        try:                
            # ---------------------------------------------------------------------------------------------
            # INFORM PUT OPERATION VIA PIPE'S PUBLISHER CHANNEL 
            # ---------------------------------------------------------------------------------------------
            if ack2put is True:
                message2send4five = "<ack2put4xi>queue2five</ack2put4xi>"
            else:
                message2send4five = "<nack2put4xi>queue2five</nack2put4xi>" 
 
            publisher_channel2five.send(message2send4five)
            print(" (STEP 33G/33) OF SHOOT2FIVE4XI -  SENT MESSAGE2SEND4FIVE: ", message2send4five, " TO PUBLISHER_CHANNEL2FIVE: ", publisher_channel2five, " - TIME: ", time4xi()) 
            # <ack2put4xi>queue2five</ack2put4xi> TO PUBLISHER_CHANNEL2FIVE:  <read-write PipeConnection, handle 276> - TIME:  04:40:26 06/20/10 Pacific Daylight Time 
        except:
            print(" (STEP 33H/33) OF SHOOT2FIVE4XI *** FAILED TO SEND MESSAGE2SEND4FIVE: ", message2send4five, " TO PUBLISHER_CHANNEL2FIVE: ", publisher_channel2five, " - TIME: ", time4xi()) 

        print("\n (STEP 33I/33) OF SHOOT2FIVE4XI - RETURNING QUEUE OBJECT QUEUE2FIVE4XI: ", queue2five4xi, " - TIME: ", time4xi())  
         
        return queue2five4xi    
    #</function4xi>
#</program4xi>
# -------------------------------------------------------------------------------------------------
# Recorded History                             
# ------------------------------------------------------------------------------------------------- 
#<record4xi record = "
#   test_sphere4xi.txt
#   sense-test-sphere4xi.xml
#   reason-test-sphere4xi.xml
#   ace-test-sphere4xi.xml
#"
#>



# -------------------------------------------------------------------------------------------------
# Legal Notice                             
# ------------------------------------------------------------------------------------------------- 
#<protect4xi protection = "copyright"
#   owner = "Small & Smart"
#   rights = "All rights reserved"
#   state = "California"
#   country = "United States of America"
#   references = "Legal notice at www.dragonxi.com; www.yourdragonxi.com; www.yourdragonxi.org; www.dragon2xi.com/; www.dragon4xi.com/; www.dragon8xi.com/ " 
#   codes = "Codes established in California and applicable to corporations in California"
#   compliance = "The California Law"
#   court = "Supreme Court of California, 350 McAllister Street, San Francisco, CA 94102-4783"
#/>
 

#<end4xi end = "
# -------------------------------------------------------------------------------------------------
# end of shoot2five4xi.py                             
# ------------------------------------------------------------------------------------------------- 
#"
#/>
